#include "stdafx.h"
#include "CpDbBase.h"

using namespace std;

CCpDbBase::CCpDbBase()
{

}

CCpDbBase::~CCpDbBase()
{

}

BOOL CCpDbBase::GetDBVersion(string strFile, DWORD& ulVer)
{
    LPBYTE pucBuf = NULL;
    ulVer = 0;
    ifstream file(strFile.c_str());
    DWORD ulFileLength = 0;

    if(!file.is_open())
    {
        return FALSE;
    }

    // Read database file
    file.seekg(0, ios::end);
    ulFileLength = (DWORD)file.tellg();
    file.seekg(0, ios::beg);

    if(0 == ulFileLength)
    {
        file.close();
        return FALSE;
    }
    pucBuf = new BYTE[ulFileLength];
    memset(pucBuf, 0, ulFileLength);
    file.read((CHAR *)pucBuf, ulFileLength);
    file.close();

    ulVer = *(DWORD *)(pucBuf + sizeof(DWORD));

    SAFELY_DELETE(pucBuf);

    return TRUE;
}

BOOL CCpDbBase::GetDBHeader(LPBYTE pucBuffer, STRUCT_CP_DB_FILE_HEADER& stHeader)
{
    stHeader.ulMagic = *(DWORD *)pucBuffer;
    stHeader.ulVersion = *(DWORD *)(pucBuffer + sizeof(DWORD));
    stHeader.ulFileLength = *(DWORD *)(pucBuffer + sizeof(DWORD) + sizeof(DWORD));

    if(stHeader.ulMagic == UL_CP_DB_MAGIC)
    {
        return TRUE;
    }

    return FALSE;
}

BOOL CCpDbBase::CopyStringToBuff(std::string strSrc, BYTE*& pucStrbuff, DWORD& ulStrBuffIndex, DWORD& ulStrBuffLen)
{

    memcpy(pucStrbuff + ulStrBuffIndex, strSrc.c_str(), strSrc.length() + 1);
    ulStrBuffIndex += (DWORD)strSrc.length() + 1;

    return TRUE;
}

BOOL CCpDbBase::CopyStructToBuff(void* pSrc, DWORD ulSrcSize, BYTE*& pucDes, DWORD& ulBuffIndex, DWORD& ulBuffLen)
{
    BYTE* pucDesfTemp = NULL;

    while((ulBuffIndex + ulSrcSize) > ulBuffLen)
    {
        ulBuffLen += UL_CP_MAX_BUFFER_LENGTH;
        pucDesfTemp = new BYTE[ulBuffLen];
        memset(pucDesfTemp, 0, ulBuffLen);
        memcpy(pucDesfTemp, pucDes, ulBuffLen - UL_CP_MAX_BUFFER_LENGTH);
        SAFELY_DELETE(pucDes);
        pucDes = pucDesfTemp;
    }

    memcpy(pucDes + ulBuffIndex, pSrc, ulSrcSize);
    ulBuffIndex += ulSrcSize;

    return TRUE;
}

BOOL CCpDbBase::CopyBuffToString(BYTE *pucStrBuf, DWORD ulOffset, std::string& strRet)
{
    CHAR *pcIndex = (CHAR *)pucStrBuf + ulOffset;

    strRet = pcIndex;

    return TRUE;
}
