#include "stdafx.h"
#include "CpIspSetting.h"
#include <fstream>
#include "../../Tool_Common/CpRsFuncBase.h"

using namespace std;

//////////////////////////////////////////////CCpDeviceSelSetting////////////////////////////////////////////////////////
CCpDeviceSelSetting::CCpDeviceSelSetting()
{
}

CCpDeviceSelSetting::~CCpDeviceSelSetting()
{
}

//////////////////////////////////////////////CCpDbIspFlowSetting////////////////////////////////////////////////////////
CCpDbIspFlowSetting::CCpDbIspFlowSetting()
{

}

CCpDbIspFlowSetting::~CCpDbIspFlowSetting()
{

}

BOOL CCpDbIspFlowSetting::SaveDB(string strDBFile, CCpIspFlowSetting& cpSetting)
{
    BYTE* pucBuff = NULL;
    DWORD ulFileLength = 0, ulBuffIndex = 0;
    ENUM_ISP_FUNCTION_TYPE enumFuncType;
    BOOL bFlag = FALSE;
    BYTE ucTemp = 0;
    DWORD ulTemp = 0;
    std::string strTemp;
    std::map<DWORD, STRUCT_FW_BANK_SETTING, sortAscending<DWORD> > mapFw;
    ENUM_SPECIFY_FLASH_MISMATCH_DETECTED enumFlashMismatch;
    ENUM_ERASE_FLASH_TYPE enumEraseType;
    std::map<DWORD, STRUCT_RESERVE_ITEM> mapReservedItem;
    STRUCT_BOOT_FLAG_SETTING stFlag;

    pucBuff = new BYTE[UL_CP_MAX_BUFFER_LENGTH];
    ulFileLength = UL_CP_MAX_BUFFER_LENGTH;
    memset(pucBuff, 0, UL_CP_MAX_BUFFER_LENGTH);

    //////////////////////////////////////////////////////////////////////////
    // Fw setting
    //////////////////////////////////////////////////////////////////////////
    // std::map<DWORD, STRUCT_FW_BANK_SETTING, sortAscending<DWORD>> m_mapFw
    cpSetting.GetProgramFwMap(mapFw);
    SaveProgramFwDB(mapFw, pucBuff, ulBuffIndex, ulFileLength);

    // ENUM_ISP_FUNCTION_TYPE m_enumFuncType
    enumFuncType = cpSetting.GetIspFunctionType();
    CopyStructToBuff(&enumFuncType, sizeof(ENUM_ISP_FUNCTION_TYPE), pucBuff, ulBuffIndex, ulFileLength);

    // DWORD m_ulProgStartBank
    ulTemp = cpSetting.GetProgramStartBank();
    CopyStructToBuff(&ulTemp, sizeof(DWORD), pucBuff, ulBuffIndex, ulFileLength);

    //////////////////////////////////////////////////////////////////////////
    // Basic setting
    //////////////////////////////////////////////////////////////////////////
    // BOOL m_bAutoDetectSlave
    bFlag = cpSetting.GetAutoDetectSlave();
    CopyStructToBuff(&bFlag, sizeof(BOOL), pucBuff, ulBuffIndex, ulFileLength);

    // BYTE m_ucSpecifiedSlave
    ucTemp = cpSetting.GetSpecifiedSlave();
    CopyStructToBuff(&ucTemp, sizeof(BYTE), pucBuff, ulBuffIndex, ulFileLength);

    // BOOL m_bIspBeforeAcOn
    bFlag = cpSetting.GetIspBeforeAcOn();
    CopyStructToBuff(&bFlag, sizeof(BOOL), pucBuff, ulBuffIndex, ulFileLength);

    // DWORD m_ulTimeBeforeAcOn
    ulTemp = cpSetting.GetTimeBeforeAcOn();
    CopyStructToBuff(&ulTemp, sizeof(DWORD), pucBuff, ulBuffIndex, ulFileLength);

    // BOOL m_bResetMcu
    bFlag = cpSetting.GetResetMcu();
    CopyStructToBuff(&bFlag, sizeof(BOOL), pucBuff, ulBuffIndex, ulFileLength);

    // DWORD m_ulIspSpeed
    ulTemp = cpSetting.GetIspSpeed();
    CopyStructToBuff(&ulTemp, sizeof(DWORD), pucBuff, ulBuffIndex, ulFileLength);

    // BOOL m_bSaveResult
    bFlag = cpSetting.GetSaveResult();
    CopyStructToBuff(&bFlag, sizeof(BOOL), pucBuff, ulBuffIndex, ulFileLength);

    // BOOL m_bSaveDebugLog
    bFlag = cpSetting.GetSaveDebugLog();
    CopyStructToBuff(&bFlag, sizeof(BOOL), pucBuff, ulBuffIndex, ulFileLength);

    // BOOL m_bSaveProgress
    bFlag = cpSetting.GetSaveProgress();
    CopyStructToBuff(&bFlag, sizeof(BOOL), pucBuff, ulBuffIndex, ulFileLength);

    // DWORD m_ulTimeAfterReset
    ulTemp = cpSetting.GetTimeAfterReset();
    CopyStructToBuff(&ulTemp, sizeof(DWORD), pucBuff, ulBuffIndex, ulFileLength);

    //////////////////////////////////////////////////////////////////////////
    // Flash type setting
    //////////////////////////////////////////////////////////////////////////
    // BOOL m_bAutoDetectFlash
    bFlag = cpSetting.GetAutoDetectFlash();
    CopyStructToBuff(&bFlag, sizeof(BOOL), pucBuff, ulBuffIndex, ulFileLength);

    // std::string m_strSpecifiedFlashName;
    strTemp = cpSetting.GetSpecifiedFlashName();
    CopyStringToBuff(strTemp, pucBuff, ulBuffIndex, ulFileLength);

    // ENUM_SPECIFY_FLASH_MISMATCH_DETECTED m_enumFlashMismatch
    enumFlashMismatch = cpSetting.GetFlashMismatch();
    CopyStructToBuff(&enumFlashMismatch, sizeof(ENUM_SPECIFY_FLASH_MISMATCH_DETECTED), pucBuff, ulBuffIndex, ulFileLength);

    //////////////////////////////////////////////////////////////////////////
    // Erase setting
    //////////////////////////////////////////////////////////////////////////
    // ENUM_ERASE_FLASH_TYPE m_enumEraseType
    enumEraseType = cpSetting.GetEraseType();
    CopyStructToBuff(&enumEraseType, sizeof(ENUM_ERASE_FLASH_TYPE), pucBuff, ulBuffIndex, ulFileLength);

    //////////////////////////////////////////////////////////////////////////
    // Reserved Setting
    //////////////////////////////////////////////////////////////////////////
    // std::map<DWORD, STRUCT_RESERVE_ITEM> m_mapReservedItem
    cpSetting.GetReservedItemMap(mapReservedItem);
    SaveReservedItemDB(mapReservedItem, pucBuff, ulBuffIndex, ulFileLength);

    //////////////////////////////////////////////////////////////////////////
    // Boot flag
    //////////////////////////////////////////////////////////////////////////
    // STRUCT_BOOT_FLAG_SETTING m_stBootFlag
    stFlag = cpSetting.GetBootFlag();
    CopyStructToBuff(&stFlag, sizeof(STRUCT_BOOT_FLAG_SETTING), pucBuff, ulBuffIndex, ulFileLength);

    //////////////////////////////////////////////////////////////////////////
    // Customized setting
    //////////////////////////////////////////////////////////////////////////
    // BOOL m_bQisdaFactory
    bFlag = cpSetting.GetQisdaFactory();
    CopyStructToBuff(&bFlag, sizeof(BOOL), pucBuff, ulBuffIndex, ulFileLength);

    // save file
    ofstream file(strDBFile.c_str(), ios::out | ios::binary);
    if(file.is_open())
    {
        file.write((CHAR *)pucBuff, ulBuffIndex);
        file.close();
    }

    SAFELY_DELETE(pucBuff);
    return TRUE;
}

BOOL CCpDbIspFlowSetting::SaveProgramFwDB(std::map<DWORD, STRUCT_FW_BANK_SETTING, sortAscending<DWORD> > &mapFw, BYTE*& pucBuff, DWORD& ulBuffIndex, DWORD& ulFileLength)
{
    DWORD ulTemp = 0;
    std::string strTemp;
    std::map<DWORD, STRUCT_FW_BANK_SETTING, sortAscending<DWORD> >::iterator it = mapFw.begin();

    ulTemp = (DWORD)mapFw.size();
    CopyStructToBuff(&ulTemp, sizeof(DWORD), pucBuff, ulBuffIndex, ulFileLength);

    for(; it != mapFw.end(); ++it)
    {
        ulTemp = it->first;
        CopyStructToBuff(&ulTemp, sizeof(DWORD), pucBuff, ulBuffIndex, ulFileLength);

        ulTemp = it->second.ulFwBank;
        CopyStructToBuff(&ulTemp, sizeof(DWORD), pucBuff, ulBuffIndex, ulFileLength);

        strTemp = it->second.strFwPath;
        CopyStringToBuff(strTemp, pucBuff, ulBuffIndex, ulFileLength);
    }

    return TRUE;
}

BOOL CCpDbIspFlowSetting::SaveReservedItemDB(std::map<DWORD, STRUCT_RESERVE_ITEM> &mapReservedItem, BYTE*& pucBuff, DWORD& ulBuffIndex, DWORD& ulFileLength)
{
    DWORD ulTemp = 0;
    bool bFlag = 0; 
    BYTE ucTemp = 0;
    WORD usTemp = 0;
    std::map<DWORD, STRUCT_RESERVE_ITEM>::iterator it = mapReservedItem.begin();

    ulTemp = (DWORD)mapReservedItem.size();
    CopyStructToBuff(&ulTemp, sizeof(DWORD), pucBuff, ulBuffIndex, ulFileLength);

    for(; it != mapReservedItem.end(); ++it)
    {
        ucTemp = it->second.ucBankIndex;
        CopyStructToBuff(&ucTemp, sizeof(BYTE), pucBuff, ulBuffIndex, ulFileLength);

        bFlag = it->second.bSave;
        CopyStructToBuff(&bFlag, sizeof(BOOL), pucBuff, ulBuffIndex, ulFileLength);

        usTemp = it->second.usStartAddr;
        CopyStructToBuff(&usTemp, sizeof(WORD), pucBuff, ulBuffIndex, ulFileLength);

        ulTemp = it->second.ulLen;
        CopyStructToBuff(&ulTemp, sizeof(DWORD), pucBuff, ulBuffIndex, ulFileLength);

        ucTemp = it->second.ucEraseSectorCount;
        CopyStructToBuff(&ucTemp, sizeof(BYTE), pucBuff, ulBuffIndex, ulFileLength);

        bFlag = it->second.bAuto;
        CopyStructToBuff(&bFlag, sizeof(BOOL), pucBuff, ulBuffIndex, ulFileLength);
    }

    return TRUE;
}

BOOL CCpDbIspFlowSetting::LoadDB(string strDBFile, CCpIspFlowSetting& cpSetting)
{
    LPBYTE pucBuf = NULL;
    DWORD ulFileLength = 0;

    // file exist
    ifstream file(strDBFile.c_str());
    if(!file.is_open())
    {
        return FALSE;
    }

    // Read file
    file.seekg(0, ios::end);
    ulFileLength = (DWORD)file.tellg();
    file.seekg(0, ios::beg);

    if(0 == ulFileLength)
    {
        file.close();
        return FALSE;
    }
    pucBuf = new BYTE[ulFileLength];
    memset(pucBuf, 0, ulFileLength);
    file.read((CHAR *)pucBuf, ulFileLength);
    file.close();

    LoadDBInfo(pucBuf, cpSetting);

    SAFELY_DELETE(pucBuf);

    return TRUE;
}

BOOL CCpDbIspFlowSetting::LoadDBInfo(LPBYTE pucBuf, CCpIspFlowSetting& cpSetting)
{
    DWORD ulOffset = 0;
    BOOL bFlag = FALSE;
    BYTE ucTemp = 0;
    DWORD ulTemp = 0;
    std::string strTemp;
    ENUM_ISP_FUNCTION_TYPE enumFuncType;
    ENUM_SPECIFY_FLASH_MISMATCH_DETECTED enumFlashMismatch;
    ENUM_ERASE_FLASH_TYPE enumEraseType;
    std::map<DWORD, STRUCT_RESERVE_ITEM> mapReservedItem;
    STRUCT_BOOT_FLAG_SETTING stFlag;

    cpSetting.Reset();

    //////////////////////////////////////////////////////////////////////////
    // Fw setting
    //////////////////////////////////////////////////////////////////////////
    // std::map<DWORD, STRUCT_FW_BANK_SETTING, sortAscending<DWORD>> m_mapFw
    LoadProgramFwDB(pucBuf, ulOffset, cpSetting);

    // ENUM_ISP_FUNCTION_TYPE m_enumFuncType
    enumFuncType = *(ENUM_ISP_FUNCTION_TYPE *)(pucBuf + ulOffset);
    cpSetting.SetIspFunctionType(enumFuncType);
    ulOffset += sizeof(ENUM_ISP_FUNCTION_TYPE);

    // DWORD m_ulProgStartBank
    ulTemp = *(DWORD *)(pucBuf + ulOffset);
    cpSetting.SetProgramStartBank(ulTemp);
    ulOffset += sizeof(DWORD);

    //////////////////////////////////////////////////////////////////////////
    // Basic setting
    //////////////////////////////////////////////////////////////////////////
    // BOOL m_bAutoDetectSlave
    bFlag = *(BOOL *)(pucBuf + ulOffset);
    cpSetting.SetAutoDetectSlave(bFlag);
    ulOffset += sizeof(BOOL);

    // BYTE m_ucSpecifiedSlave
    ucTemp = *(BYTE *)(pucBuf + ulOffset);
    cpSetting.SetSpecifiedSlave(ucTemp);
    ulOffset += sizeof(BYTE);

    // BOOL m_bIspBeforeAcOn
    bFlag = *(BOOL *)(pucBuf + ulOffset);
    cpSetting.SetIspBeforeAcOn(bFlag);
    ulOffset += sizeof(BOOL);

    // DWORD m_ulTimeBeforeAcOn
    ulTemp = *(DWORD *)(pucBuf + ulOffset);
    cpSetting.SetTimeBeforeAcOn(ulTemp);
    ulOffset += sizeof(DWORD);

    // BOOL m_bResetMcu
    bFlag = *(BOOL *)(pucBuf + ulOffset);
    cpSetting.SetResetMcu(bFlag);
    ulOffset += sizeof(BOOL);

    // DWORD m_ulIspSpeed
    ulTemp = *(DWORD *)(pucBuf + ulOffset);
    cpSetting.SetIspSpeed(ulTemp);
    ulOffset += sizeof(DWORD);

    // BOOL m_bSaveResult
    bFlag = *(BOOL *)(pucBuf + ulOffset);
    cpSetting.SetSaveResult(bFlag);
    ulOffset += sizeof(BOOL);

    // BOOL m_bSaveDebugLog
    bFlag = *(BOOL *)(pucBuf + ulOffset);
    cpSetting.SetSaveDebugLog(bFlag);
    ulOffset += sizeof(BOOL);

    // BOOL m_bSaveProgress
    bFlag = *(BOOL *)(pucBuf + ulOffset);
    cpSetting.SetSaveProgress(bFlag);
    ulOffset += sizeof(BOOL);

    // DWORD m_ulTimeAfterReset
    ulTemp = *(DWORD *)(pucBuf + ulOffset);
    cpSetting.SetTimeAfterReset(ulTemp);
    ulOffset += sizeof(DWORD);

    //////////////////////////////////////////////////////////////////////////
    // Flash type setting
    //////////////////////////////////////////////////////////////////////////
    // BOOL m_bAutoDetectFlash
    bFlag = *(BOOL *)(pucBuf + ulOffset);
    cpSetting.SetAutoDetectFlash(bFlag);
    ulOffset += sizeof(BOOL);

    // std::string m_strSpecifyFlashName
    CopyBuffToString(pucBuf, ulOffset, strTemp);
    cpSetting.SetSpecifiedFlashName(strTemp);
    ulOffset += (DWORD)(strlen((CHAR *)(pucBuf + ulOffset)) + 1) * sizeof(BYTE);

    // ENUM_SPECIFY_FLASH_MISMATCH_DETECTED m_enumFlashMismatch
    enumFlashMismatch = *(ENUM_SPECIFY_FLASH_MISMATCH_DETECTED *)(pucBuf + ulOffset);
    cpSetting.SetFlashMismatch(enumFlashMismatch);
    ulOffset += sizeof(ENUM_SPECIFY_FLASH_MISMATCH_DETECTED);

    //////////////////////////////////////////////////////////////////////////
    // Erase setting
    //////////////////////////////////////////////////////////////////////////
    // ENUM_ERASE_FLASH_TYPE m_enumEraseType
    enumEraseType = *(ENUM_ERASE_FLASH_TYPE *)(pucBuf + ulOffset);
    cpSetting.SetEraseType(enumEraseType);
    ulOffset += sizeof(ENUM_ERASE_FLASH_TYPE);

    //////////////////////////////////////////////////////////////////////////
    // Reserved Setting
    //////////////////////////////////////////////////////////////////////////
    // std::map<DWORD, STRUCT_RESERVE_ITEM> m_mapReservedItem
    LoadReservedItemDB(pucBuf, ulOffset, cpSetting);

    //////////////////////////////////////////////////////////////////////////
    // Boot flag
    //////////////////////////////////////////////////////////////////////////
    // STRUCT_BOOT_FLAG_SETTING m_stBootFlag
    stFlag = *(STRUCT_BOOT_FLAG_SETTING *)(pucBuf + ulOffset);
    cpSetting.SetBootFlag(stFlag);
    ulOffset += sizeof(STRUCT_BOOT_FLAG_SETTING);

    //////////////////////////////////////////////////////////////////////////
    // Customized setting
    //////////////////////////////////////////////////////////////////////////
    // BOOL m_bQisdaFactory
    bFlag = *(BOOL *)(pucBuf + ulOffset);
    cpSetting.SetQisdaFactory(bFlag);
    ulOffset += sizeof(BOOL);

    return TRUE;
}

BOOL CCpDbIspFlowSetting::LoadProgramFwDB(LPBYTE pucBuf, DWORD& ulOffset, CCpIspFlowSetting& cpSetting)
{
    DWORD ulBankCnt = 0, ulTemp = 0, ulKey = 0;
    std::map<DWORD, STRUCT_FW_BANK_SETTING, sortAscending<DWORD> > mapFw;
    std::string strTemp;
    STRUCT_FW_BANK_SETTING stFwBank;

    mapFw.clear();

    // Program fw bank count
    ulBankCnt = *(DWORD *)(pucBuf + ulOffset);
    ulOffset += sizeof(DWORD);

    for(DWORD ulIndex = 0; ulIndex < ulBankCnt; ulIndex++)
    {
        ulKey = *(DWORD *)(pucBuf + ulOffset);
        ulOffset += sizeof(DWORD);

        ulTemp = *(DWORD *)(pucBuf + ulOffset);
        stFwBank.ulFwBank = ulTemp;
        ulOffset += sizeof(DWORD);

        CopyBuffToString(pucBuf, ulOffset, strTemp);
        stFwBank.strFwPath = strTemp;
        ulOffset += (DWORD)(strlen((CHAR *)(pucBuf + ulOffset)) + 1) * sizeof(BYTE);

        mapFw.insert(std::make_pair(ulKey, stFwBank));
    }

    cpSetting.SetProgramFwMap(mapFw);

    return TRUE;
}

BOOL CCpDbIspFlowSetting::LoadReservedItemDB(LPBYTE pucBuf, DWORD& ulOffset, CCpIspFlowSetting& cpSetting)
{
    DWORD ulRevCnt = 0, ulTemp = 0;
    BYTE ucTemp = 0;
    BOOL bFlag = FALSE;
    WORD usTemp = 0;
    std::map<DWORD, STRUCT_RESERVE_ITEM> mapReservedItem;
    STRUCT_RESERVE_ITEM stRevItem;

    mapReservedItem.clear();

    // reserved item count
    ulRevCnt = *(DWORD *)(pucBuf + ulOffset);
    ulOffset += sizeof(DWORD);

    for(DWORD ulIndex = 0; ulIndex < ulRevCnt; ulIndex++)
    {
        ucTemp = *(BYTE *)(pucBuf + ulOffset);
        stRevItem.ucBankIndex = ucTemp;
        ulOffset += sizeof(BYTE);

        bFlag = *(BOOL *)(pucBuf + ulOffset);
        stRevItem.bSave = bFlag;
        ulOffset += sizeof(BOOL);

        usTemp = *(WORD *)(pucBuf + ulOffset);
        stRevItem.usStartAddr = usTemp;
        ulOffset += sizeof(WORD);

        ulTemp = *(DWORD *)(pucBuf + ulOffset);
        stRevItem.ulLen = ulTemp;
        ulOffset += sizeof(DWORD);

        ucTemp = *(BYTE *)(pucBuf + ulOffset);
        stRevItem.ucEraseSectorCount = ucTemp;
        ulOffset += sizeof(BYTE);

        bFlag = *(BOOL *)(pucBuf + ulOffset);
        stRevItem.bAuto = bFlag;
        ulOffset += sizeof(BOOL);

        mapReservedItem.insert(std::make_pair(ulIndex, stRevItem));
    }

    cpSetting.SetReservedItemMap(mapReservedItem);

    return TRUE;
}

//////////////////////////////////////////////CCpIspFlowSetting////////////////////////////////////////////////////////
CCpIspFlowSetting::CCpIspFlowSetting()
{
	Reset();
}

CCpIspFlowSetting::~CCpIspFlowSetting()
{
}

void CCpIspFlowSetting::Reset()
{
    m_enumCommID = _ENUM_COMM_UNKNOWN;
    m_stReadVer.bNeedRead = false;
    m_stReadVer.enumType = _ENUM_VER_FROM_REG;

    m_mapFw.clear();
    m_enumFuncType = _ENUM_FUNC_UNKNOWN;
    m_ulProgStartBank = 0;

    // Basic setting
    m_bAutoDetectSlave = TRUE;
    m_ucSpecifiedSlave = 0x94;
    m_bIspBeforeAcOn = TRUE;
    m_ulTimeBeforeAcOn = 2500;
    m_bResetMcu = TRUE;
    m_ulIspSpeed = 200;
    m_bSaveResult = FALSE;
    m_bSaveDebugLog = FALSE;
    m_bSaveProgress = FALSE;
    m_ulTimeAfterReset = 5000;

    // Flash type setting
    m_bAutoDetectFlash = TRUE;
    m_strSpecifiedFlashName.clear();
    m_enumFlashMismatch = _ENUM_SPECIFIED_ONE;

    // Erase setting
    m_enumEraseType = _ENUM_FLASH_BANK_ERASE;

    // Reserved Setting
    m_mapReservedItem.clear();

    // Boot flag
    m_stBootFlag.ulAddr = 0;
    memset(m_stBootFlag.ucszFlag, 0xFF, sizeof(m_stBootFlag.ucszFlag));

    // Customized setting
    m_bQisdaFactory = FALSE;
}