
#ifdef RTUSBISPBOARD
#include "../CommRTUsb/LinuxRTUsbIspBoard.h"
CRTUsbIspBoard g_cpDevCommCtrl;
#endif

#ifdef RTLCDTYPECUSB
#include "../CommRslcdTypeCUsb/LinuxRslcdTypeCUsb.h"
CRTlcdTypeCUsb g_cpDevCommCtrl;
#endif

#ifdef HUB2IIC
#include "../CommHub2IIC/LinuxHub2IIC.h"
CHub2IIC g_cpDevCommCtrl;
#endif

#ifdef SMBUS
#include "../CommSmbus/LinuxSmbus.h"
CSmbus g_cpDevCommCtrl;
#endif

#ifdef DEVI2C
#include "../CommDevI2C/LinuxDevI2C.h"
CDevI2C g_cpDevCommCtrl;
#endif

#ifdef __cplusplus
extern "C" {
#endif

    STRUCT_ENUM_ERROR_TYPE InitialDev();
    STRUCT_ENUM_ERROR_TYPE ReleaseDev();
    STRUCT_ENUM_COMM_ID GetCommID();
    void GetCommName(TCHAR *pcName, WORD usLength);
    WORD GetI2CPageLength();
    WORD GetNativePageLength();
    STRUCT_ENUM_ERROR_TYPE I2CWrite(BYTE ucSlave, BYTE ucSub, WORD usLength, const BYTE* pucBuf);
    STRUCT_ENUM_ERROR_TYPE I2CRead(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf);
    STRUCT_ENUM_ERROR_TYPE I2CWriteByte(BYTE ucSlave, BYTE ucSub, BYTE ucValue);
    STRUCT_ENUM_ERROR_TYPE I2CCurrentRead(BYTE ucSlave, WORD usLength, BYTE* pucBuf);
    STRUCT_ENUM_ERROR_TYPE I2CWordWrite(BYTE ucSlave, WORD usSub, WORD usLength, const BYTE* pucBuf);
    STRUCT_ENUM_ERROR_TYPE I2CWordRead(BYTE ucSlave, WORD usSub, WORD usLength, BYTE* pucBuf);
    STRUCT_ENUM_ERROR_TYPE AdjustOption();
    STRUCT_ENUM_ERROR_TYPE SetI2CSpeed(WORD usSpeed);
    WORD GetI2CSpeed();
    STRUCT_ENUM_ERROR_TYPE SetAuxMode(STRUCT_AUXMODE_STRUCT stAuxMode);
    STRUCT_ENUM_ERROR_TYPE SetWaitingMode(STRUCT_WAITING_STRUCT stWaiting);
    STRUCT_WAITING_STRUCT GetWaitingMode();
    STRUCT_ENUM_ERROR_TYPE NativeWrite(INT nAddress, WORD usLength, const BYTE* pucBuf);
    STRUCT_ENUM_ERROR_TYPE NativeRead(INT nAddress, WORD usLength, BYTE* pucBuf);
    STRUCT_ENUM_ERROR_TYPE SetSettingFilePath(TCHAR *pcConfigFilePath);
    void * GetDeviceHandler();
    STRUCT_ENUM_ERROR_TYPE ResetFirmware();
    DWORD GetSMBUSDataType();
    STRUCT_ENUM_ERROR_TYPE SetSMBUSDataType(DWORD ulSMBUSDataType);
    BYTE GetDeviceCount();
    STRUCT_ENUM_ERROR_TYPE RemoveDevice();
    STRUCT_ENUM_ERROR_TYPE SetFTDIGetAck(BOOL bEnable);
    BOOL GetFTDIGetAckStatus();
    STRUCT_ENUM_ERROR_TYPE GetUsbDevicePath(BYTE ucIndex, TCHAR* pcszDevicePath);
    STRUCT_ENUM_ERROR_TYPE SelectUsbByDevicePath(TCHAR* pcszDevicePath);
    STRUCT_ENUM_ERROR_TYPE SelectUsbByIndex(BYTE ucIndex);
    void SetCmdLine(TCHAR *pcCmd);
    STRUCT_ENUM_ERROR_TYPE I2CWriteSegment(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const BYTE* pucBuf);
    STRUCT_ENUM_ERROR_TYPE I2CReadSegment(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const BYTE* pucBuf);
    STRUCT_ENUM_ERROR_TYPE SendUsbPacket(BYTE bRequest, WORD usValue, WORD usIndex, WORD usLength, void * pData);
    STRUCT_ENUM_ERROR_TYPE ReceiveUsbPacket(BYTE bRequest, WORD usValue, WORD usIndex, WORD usLength, void * pData);

#ifdef __cplusplus
} // extern "C"
#endif

