#include "LinuxDevI2C.h"
#include "CpDeviceComBase.h"

BOOL g_bInitFlag = false;
CDevI2CRw g_cDevI2CRW;


CDevI2C::CDevI2C(void)
{
}

CDevI2C::~CDevI2C(void)
{
}

STRUCT_ENUM_ERROR_TYPE CDevI2C::InitialDev()
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    
    g_bInitFlag = false;
    enumError = g_cDevI2CRW.InitI2CDev();
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    
    g_bInitFlag = true;
    return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE CDevI2C::ReleaseDev()
{
    if (!g_bInitFlag)
    {
        return _ERROR_SUCCESS;
    }

    g_bInitFlag = false;
    return g_cDevI2CRW.ReleaseI2CDev();
}

void CDevI2C::GetCommName(TCHAR *pcName, WORD usLength)
{
    strcpy(pcName, "DevI2C");
}

STRUCT_ENUM_COMM_ID CDevI2C::GetCommID()
{
    return _ENUM_COMM_LINUXDEVI2C;
}

WORD CDevI2C::GetI2CPageLength()
{
    return US_I2C_PAGELENGTH;
}


STRUCT_ENUM_ERROR_TYPE CDevI2C::I2CWrite(BYTE ucSlave, BYTE ucSub, WORD usLength, const BYTE* pucBuf)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    if (usLength > US_I2C_PAGELENGTH)
    {
        return _ERROR_COMM_USBDHUBI2C_I2C_PAGELENGTH_UNSUPPORT;
    }

    if (!g_bInitFlag)
    {
        enumError = InitialDev();
        if (_ERROR_SUCCESS != enumError)
        {
            return enumError;
        }
    }

    return g_cDevI2CRW.IICWrite(ucSlave, ucSub, usLength, pucBuf);

}

STRUCT_ENUM_ERROR_TYPE CDevI2C::I2CRead(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    if (usLength > US_I2C_PAGELENGTH)
    {
        return _ERROR_COMM_USBDHUBI2C_I2C_PAGELENGTH_UNSUPPORT;
    }

    if (!g_bInitFlag)
    {
        enumError = InitialDev();
        if (_ERROR_SUCCESS != enumError)
        {
            return enumError;
        }
    }
    return g_cDevI2CRW.IICRead(ucSlave, ucSub, usLength, pucBuf);
}
