//#define DLL_EXPORT
#include "stdafx.h"
#include "Comm.h"
#include <stdio.h>
#include <string.h>
#include "../Comm_PlugIn/Comm_PlugIn_Export/CPComm_PlugIn_Define/CpCommPlugInExport.h"
#include <string.h>
#include <iostream>
#include <vector>
#include "../Tool_Common/RsCommon/RegDef.h"
#include "Comm_Export/CpCommInclude.h"

using namespace  std;
VECTORDEVICEINFO g_vectDeviceInfo;
CCpRsString g_strCurrentDir;

CONST BYTE UC_PAGESELREG = 0x9F;
CONST BYTE UC_NEW_XDATA_MAX_LEN = 24;
CONST BYTE UC_NEW_XDATA_32BIT_REG_PAGE_LEN = UC_NEW_XDATA_MAX_LEN / sizeof(DWORD); // UC_NEW_XDATA_MAX_LEN/ sizeof(DWORD)
CONST BYTE UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN = UC_NEW_XDATA_MAX_LEN / sizeof(WORD); // UC_NEW_XDATA_MAX_LEN/ sizeof(DWORD)

CONST INT N_TRY_COUNT = 600;

#define _SCALER_DEBUG_DATA_LEN_ERROR          0xE1
#define _SCALER_DEBUG_CHECKSUM_ERROR          0xE2

//////////////////////////////////////////////////////////////////////////
// TypeC usb vendor cmd define
#define _USB_VENDOR_SET_REGISTER_VALUE                   0x01
#define _USB_VENDOR_GET_REGISTER_VALUE                   0x02
#define _USB_VENDOR_WRITE_SYSEEPROM                      0x03
#define _USB_VENDOR_READ_SYSEEPROM                       0x04

#define _USB_VENDOR_DEBUGMSG_EVENT_START                 0x30
#define _USB_VENDOR_DEBUGMSG_EVENT_FINISH                0x31
#define _USB_VENDOR_DEBUGMSG_START                       0x32
#define _USB_VENDOR_DEBUGMSG_END                         0x33
#define _USB_VENDOR_DEBUGMSG_GET_VALUE                   0x34
#define _USB_VENDOR_DEBUGMSG_GET_STRING                  0x35

#define _USB_VENDOR_WRITE_TO_FLASH                       0x40
#define _USB_VENDOR_READ_FROM_FLASH                      0x41
#define _USB_VENDOR_FLASH_SECTOR_ERASE                   0x42
#define _USB_VENDOR_FLASH_BANK_ERASE                     0x43
#define _USB_VENDOR_ISP_ENABLE                           0x44
//////////////////////////////////////////////////////////////////////////

typedef enum STRUCT_ENUM_SCALER_DEBUG_CMD_TYPE
{
    _SCALER_DEBUG_CMD_START = 0,
    _SCALER_USELESS_READ_CMD = 0x08,

    _SCALER_WTITE_PWM2SPI_CMD = 0x9A,
    _SCALER_READ_PWM2SPI_CMD = 0x9B,
    _SCALER_WTITE_PWM2SPI_DEV_CMD = 0x9C,
    _SCALER_READ_PWM2SPI_DEV_CMD = 0x9D,

    _SCALER_WTITE_32BITSREGISTERS_CMD = 0xAA,
    _SCALER_READ_32BITSREGISTERS_CMD = 0xAB,
    _SCALER_WTITE_DDRREGISTERS_CMD = 0xAC,
    _SCALER_READ_DDRREGISTERS_CMD = 0xAD,

    _SCALER_WTITE_16BITSREGISTERS_CMD = 0xBA,
    _SCALER_READ_16BITSREGISTERS_CMD = 0xBB,

    _SCALER_DEBUG_CMD_END = 0xFFFF,

}STRUCT_ENUM_SCALER_DEBUG_CMD_TYPE;

#define UC_NORMAL_DEBUG_SLAVE 0x6A
#define UC_NORMAL_ISP_SLAVE 0x94
#define UC_NORMAL_ISP_CONTINUOUS_SLAVE 0x96
CONST BYTE UC_AUTO_DETECT_SLAVE_ADDR_TIME = 0x02;

BYTE g_ucDebugSlave = UC_NORMAL_DEBUG_SLAVE;
BYTE g_ucIspSlave = UC_NORMAL_ISP_SLAVE;
BYTE g_ucIspContinuousSlave = UC_NORMAL_ISP_CONTINUOUS_SLAVE;
STRUCT_ENUM_DEBUG_TYPE g_enumDebugMode = _DEBUG_ISP;
STRUCT_ENUM_SPECIAL_COMM_TYPE g_enumSpecialCommType = _ENUM_SPECIAL_COMM_NORMAL;
STRUCT_ENUM_SPECIAL_COMM_TYPE g_enumSpecialCommTypeTmp = _ENUM_SPECIAL_COMM_NORMAL;

BYTE g_ucCurPage = 0x00;
BOOL g_bPageMark = FALSE;
BOOL g_bNeedAutoDetectSlave = TRUE;
BYTE g_ucAutoDetectSlaveCount = 0;
BYTE g_ucOldISPSalve = 0x00;
CCpRsString g_cpstrConfigPath;
CCpRsString g_cpstrCmd;

STRUCT_ENUM_ERROR_TYPE ReadRegNewXdata(WORD usReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE WriteRegNewXdata(WORD usReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE Read32BitRegEx(DWORD ulReg, DWORD* pulValue);
STRUCT_ENUM_ERROR_TYPE Write32BitRegEx(DWORD ulReg, DWORD ulValue);
STRUCT_ENUM_ERROR_TYPE Read32BitRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE Write32BitRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE Write32BitRegsExThroughFW(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE Read32BitRegsExThroughFW(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE Write32BitRegsExThrough8To32Interface(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE Read32BitRegsExThrough8To32Interface(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);

STRUCT_ENUM_ERROR_TYPE ReadDDRRegEx(DWORD ulReg, DWORD* pulValue);
STRUCT_ENUM_ERROR_TYPE WriteDDRRegEx(DWORD ulReg, DWORD ulValue);
STRUCT_ENUM_ERROR_TYPE ReadDDRRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE WriteDDRRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE WriteDDRRegsExThroughFW(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE ReadDDRRegsExThroughFW(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE WriteDDRRegsExThroughMCMMode(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE ReadDDRRegsExThroughMCMMode(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE ReadPWM2SPIReg(BYTE ucDevIndex, BYTE ucRegStartAddr, BYTE ucLength, BYTE *pucBuf);
STRUCT_ENUM_ERROR_TYPE WritePWM2SPIReg(BYTE ucDevIndex, BYTE ucRegStartAddr, BYTE ucLength, BYTE *pucBuf);
STRUCT_ENUM_ERROR_TYPE ReadPWM2SPIRegThroughFW(BYTE ucDevIndex, BYTE ucRegStartAddr, BYTE ucLength, BYTE *pucBuf);
STRUCT_ENUM_ERROR_TYPE WritePWM2SPIRegThroughFW(BYTE ucDevIndex, BYTE ucRegStartAddr, BYTE ucLength, BYTE *pucBuf);
STRUCT_ENUM_ERROR_TYPE ReadPWM2SPIDev(BYTE ucDevIndex, BYTE ucPwmStartIndex, BYTE ucPwmNum, WORD *pusBuf);
STRUCT_ENUM_ERROR_TYPE WritePWM2SPIDev(BYTE ucDevIndex, BYTE ucPwmStartIndex, BYTE ucPwmNum, WORD *pusBuf);
STRUCT_ENUM_ERROR_TYPE ReadPWM2SPIDevThroughFW(BYTE ucDevIndex, BYTE ucPwmStartIndex, BYTE ucPwmNum, WORD *pusBuf);
STRUCT_ENUM_ERROR_TYPE WritePWM2SPIDevThroughFW(BYTE ucDevIndex, BYTE ucPwmStartIndex, BYTE ucPwmNum, WORD *pusBuf);
STRUCT_ENUM_ERROR_TYPE StepTraceRead(WORD usXdataAddr, BYTE* pucBuf);
STRUCT_ENUM_ERROR_TYPE StepTraceWrite(WORD usXdataAddr, BYTE ucValue);
STRUCT_ENUM_ERROR_TYPE EnterStepTraceDebugMode();


BYTE GetHwI2CReadPageLength()
{
    return _HW_IIC_READ_PAGE_LEN;
}

WORD GetHwI2CWritePageLength()
{
    return _HW_IIC_WRITE_PAGE_LEN;
}

// Wait until result == (ucTarget & unAnd) or nTryCount == 0, the later one return False
STRUCT_ENUM_ERROR_TYPE WaitRegForBitChange(BYTE ucRegister, BYTE ucAnd, BYTE ucTarget, INT nTryCount)
{
    BYTE ucData = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    INT nCommunicateCount = 5;

    ucTarget &= ucAnd;
    while(nTryCount > 0)
    {
        enumError = ReadMcuReg(ucRegister, &ucData);
        if(enumError != _ERROR_SUCCESS)
        {
            if(--nCommunicateCount > 0)
            {
                continue;
            }
            else
            {
                break;
            }
        }
        if((ucData & ucAnd) == ucTarget)
        {
            return _ERROR_SUCCESS;
        }
        Sleep(2);

        --nTryCount;
    }

    return _ERROR_COMMONFUNC_POLLINGFAIL;
}

STRUCT_ENUM_ERROR_TYPE ScalerMcuHwIICRead(BYTE ucSlaveAddr, STRUCT_ENUM_SUBADDR_TYPE enumSubAddrLength, WORD usSubAddr, BYTE ucDataLength, BYTE *pucReadArray)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    if(g_enumSpecialCommType == _ENUM_SPECIAL_COMM_IICMASTER)
    {
        g_enumSpecialCommTypeTmp = _ENUM_SPECIAL_COMM_IICMASTER;
        g_enumSpecialCommType = _ENUM_SPECIAL_COMM_NORMAL;
    }

    //////////////////////////////////////////////////////////////////////////
    // I2C Crystal clock run
    enumError = WriteMcuRegBit(_MCUREG_F2, (BYTE)(~_BIT7), 0);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // IIC Master Software Reset
    enumError = WriteMcuRegBit(_MCUREG_55, (BYTE)(~_BIT7), (BYTE)(_BIT7));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // Wait 0xFF5D[5] = 1'b1
    // I2C FIFO clock switch to mcu clock
    enumError = WaitRegForBitChange(_MCUREG_5D, _BIT5, _BIT5, 1500);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    //////////////////////////////////////////////////////////////////////////

    switch(enumSubAddrLength)
    {
    case _SUBADDR_CURRENT:
        // Set 1 byte for FRSIB
        //MCU_FF57_I2CM_CR2 &= ~(_BIT1 | _BIT0);
        enumError = WriteMcuRegBit(_MCUREG_57, (BYTE)(~(_BIT1 | _BIT0)), 0);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Set no repeat start
        //MCU_FF58_I2CM_CR3 &= ~(_BIT4 | _BIT3);
        enumError = WriteMcuRegBit(_MCUREG_58, (BYTE)(~(_BIT4 | _BIT3)), 0);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Load Slave Address to receive data
        //MCU_FF5E_I2CM_TD = ucSlaveAddr | _READ;
        enumError = WriteMcuReg(_MCUREG_5E, (BYTE)(ucSlaveAddr | _READ));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        break;

    case _SUBADDR_BYTE:
        // Set 2 bytes for FRSIB
        //MCU_FF57_I2CM_CR2 &= ~(_BIT1 | _BIT0);
        //MCU_FF57_I2CM_CR2 |= _BIT0;
        enumError = WriteMcuRegBit(_MCUREG_57, (BYTE)(~(_BIT1 | _BIT0)), (BYTE)_BIT0);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Set one repeat start
        //MCU_FF58_I2CM_CR3 &= ~_BIT4;
        //MCU_FF58_I2CM_CR3 |= _BIT3;
        enumError = WriteMcuRegBit(_MCUREG_58, (BYTE)(~_BIT4), (BYTE)_BIT3);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Load Slave Address to IIC Buffer
        //MCU_FF5E_I2CM_TD = ucSlaveAddr | _WRITE;
        enumError = WriteMcuReg(_MCUREG_5E, (BYTE)(ucSlaveAddr | _WRITE));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Load Sub-Address to IIC Buffer
        //MCU_FF5E_I2CM_TD = (BYTE)(usSubAddr);
        enumError = WriteMcuReg(_MCUREG_5E, (BYTE)usSubAddr);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Load Slave Address to receive data
        //MCU_FF5E_I2CM_TD = ucSlaveAddr | _READ;
        enumError = WriteMcuReg(_MCUREG_5E, (BYTE)(ucSlaveAddr | _READ));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        break;

    case _SUBADDR_WORD:
        // Set 3 bytes for FRSIB
        //MCU_FF57_I2CM_CR2 &= ~(_BIT1 | _BIT0);
        //MCU_FF57_I2CM_CR2 |= _BIT1;
        enumError = WriteMcuRegBit(_MCUREG_57, (BYTE)(~(_BIT1 | _BIT0)), (BYTE)_BIT1);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Set one repeat start
        //MCU_FF58_I2CM_CR3 &= ~_BIT4;
        //MCU_FF58_I2CM_CR3 |= _BIT3;
        enumError = WriteMcuRegBit(_MCUREG_58, (BYTE)(~_BIT4), (BYTE)_BIT3);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Load Slave Address to IIC Buffer
        //MCU_FF5E_I2CM_TD = ucSlaveAddr | _WRITE;
        enumError = WriteMcuReg(_MCUREG_5E, (BYTE)(ucSlaveAddr | _WRITE));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Load First Sub-Address to IIC Buffer
        //MCU_FF5E_I2CM_TD = (BYTE)((usSubAddr & 0xFF00) >> 8);
        enumError = WriteMcuReg(_MCUREG_5E, (BYTE)((usSubAddr & 0xFF00) >> 8));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Load Second Sub-Address to IIC Buffer
        //MCU_FF5E_I2CM_TD = (BYTE)(usSubAddr);
        enumError = WriteMcuReg(_MCUREG_5E, (BYTE)(usSubAddr));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Load Slave Address to receive data
        //MCU_FF5E_I2CM_TD = ucSlaveAddr | _READ;
        enumError = WriteMcuReg(_MCUREG_5E, (BYTE)(ucSlaveAddr | _READ));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        break;

    default:
        return _ERROR_COMM_I2C_MASTER_SUBADDR_NOT_SUPPORT;
    }

    if(ucDataLength < 1)
    {
        ucDataLength = 1;
    }

    // Set data length
    //MCU_FF55_I2CM_CR0 &= ~(_BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1);
    //MCU_FF55_I2CM_CR0 |= (ucDataLength - 1) << 1;
    enumError = WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1)), (BYTE)((ucDataLength - 1) << 1));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // IIC command Start
    //MCU_FF55_I2CM_CR0 |= _BIT6;
    enumError = WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT6)), (BYTE)(_BIT6));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // Wait until Master Receive Complete
    enumError = WaitRegForBitChange(_MCUREG_5D, _BIT1, _BIT1, 1500);
    if(enumError != _ERROR_SUCCESS)
    {
        if(enumError == _ERROR_COMMONFUNC_POLLINGFAIL)
        {
            // Reset(Block) IIC module
            //MCU_FF55_I2CM_CR0 &= ~_BIT7;
            WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT7)), 0);

            // Enable IIC module
            //MCU_FF55_I2CM_CR0 |= _BIT7;
            WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT7)), (BYTE)(_BIT7));
        }
        return enumError;
    }

    // Save received data
    enumError = ReadMcuRegs(_MCUREG_5E, ucDataLength, pucReadArray, _INCTYPE_NONE);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // Clear all flags
    //MCU_FF5D_I2CM_SR |= 0x07;
    enumError = WriteMcuRegBit(_MCUREG_5D, 0xF8, 0x07);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    if(g_enumSpecialCommTypeTmp == _ENUM_SPECIAL_COMM_IICMASTER)
    {
        g_enumSpecialCommType = _ENUM_SPECIAL_COMM_IICMASTER;
        g_enumSpecialCommTypeTmp = _ENUM_SPECIAL_COMM_NORMAL;
    }
    return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE ScalerMcuHwIICWrite(BYTE ucSlaveAddr, STRUCT_ENUM_SUBADDR_TYPE enumSubAddrLength, WORD usSubAddr, WORD usDataLength, BYTE *pucWriteArray)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE pData[_HW_IIC_WRITE_PRE_DATA_LEN] = {0};
    BYTE ucTempLength = 0, ucI = 0;

    if(g_enumSpecialCommType == _ENUM_SPECIAL_COMM_IICMASTER)
    {
        g_enumSpecialCommTypeTmp = _ENUM_SPECIAL_COMM_IICMASTER;
        g_enumSpecialCommType = _ENUM_SPECIAL_COMM_NORMAL;
    }
    //////////////////////////////////////////////////////////////////////////
    // I2C Crystal clock run
    enumError = WriteMcuRegBit(_MCUREG_F2, (BYTE)(~_BIT7), 0);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // IIC Master Software Reset
    enumError = WriteMcuRegBit(_MCUREG_55, (BYTE)(~_BIT7), (BYTE)(_BIT7));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // Wait 0xFF5D[5] = 1'b1
    // I2C FIFO clock switch to mcu clock
    enumError = WaitRegForBitChange(_MCUREG_5D, _BIT5, _BIT5, 1500);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    //////////////////////////////////////////////////////////////////////////

    // Set 1 byte for FRSIB
    //MCU_FF57_I2CM_CR2 &= ~(_BIT1 | _BIT0);
    enumError = WriteMcuRegBit(_MCUREG_57, (BYTE)(~(_BIT1 | _BIT0)), 0);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // Set no repeat start
    //MCU_FF58_I2CM_CR3 &= ~(_BIT4 | _BIT3);
    enumError = WriteMcuRegBit(_MCUREG_58, (BYTE)(~(_BIT4 | _BIT3)), 0);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // Wait I2C Fifo Clk Switch to Mcu Clk
    enumError = WaitRegForBitChange(_MCUREG_5D, _BIT5, _BIT5, 1500);
    if(enumError != _ERROR_SUCCESS)
    {
        if(enumError == _ERROR_COMMONFUNC_POLLINGFAIL)
        {
            // Reset(Block) IIC module
            //MCU_FF55_I2CM_CR0 &= ~_BIT7;
            WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT7)), 0);

            // Enable IIC module
            //MCU_FF55_I2CM_CR0 |= _BIT7;
            WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT7)), (BYTE)(_BIT7));
        }
        return enumError;
    }

    // Load Slave Address to IIC Buffer
    //MCU_FF5E_I2CM_TD = ucSlaveAddr | _WRITE;
    enumError = WriteMcuReg(_MCUREG_5E, (BYTE)(ucSlaveAddr | _WRITE));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    //MCU_FF55_I2CM_CR0 &= ~(_BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1);
    enumError = WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1)), 0);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    if(usDataLength > _HW_IIC_WRITE_PRE_DATA_LEN)
    {
        pData[0] = _HW_IIC_WRITE_PRE_DATA_LEN;
    }
    else
    {
        pData[0] = (BYTE)usDataLength;
    }

    if(pData[0] < 1)
    {
        pData[0] = 1;
    }

    switch(enumSubAddrLength)
    {
    case _SUBADDR_CURRENT:
        // Set data length
        ucTempLength = ((pData[0] - 1) << 1);
        break;

    case _SUBADDR_BYTE:
        // Load Sub-Address to IIC Buffer
        //MCU_FF5E_I2CM_TD = (BYTE)(usSubAddr);
        enumError = WriteMcuReg(_MCUREG_5E, (BYTE)usSubAddr);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Set data length
        ucTempLength = (pData[0] << 1);
        break;

    case _SUBADDR_WORD:
        // Load First Sub-Address to IIC Buffer
        //MCU_FF5E_I2CM_TD = (BYTE)((usSubAddr & 0xFF00) >> 8);
        enumError = WriteMcuReg(_MCUREG_5E, (BYTE)((usSubAddr & 0xFF00) >> 8));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Load Second Sub-Address to IIC Buffer
        //MCU_FF5E_I2CM_TD = (BYTE)(usSubAddr);
        enumError = WriteMcuReg(_MCUREG_5E, (BYTE)usSubAddr);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Set data length
        ucTempLength = ((pData[0] + 1) << 1);
        break;

    default:
        return _ERROR_COMM_I2C_MASTER_SUBADDR_NOT_SUPPORT;
    }

    if(usDataLength <= _HW_IIC_WRITE_PRE_DATA_LEN)
    {
        enumError = WriteMcuRegs(_MCUREG_5E, pData[0], pucWriteArray, _INCTYPE_NONE);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Send IIC command Start
        //MCU_FF55_I2CM_CR0 = 0xC0 + ucTempLength;
        enumError = WriteMcuReg(_MCUREG_55, 0xC0 + ucTempLength);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }
    else
    {
        // Disable HW TOR
        //MCU_FF55_I2CM_CR0 &= ~_BIT0;
        enumError = WriteMcuRegBit(_MCUREG_55, (BYTE)(~_BIT0), 0);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Enable Burst Mode
        //MCU_FF57_I2CM_CR2 |= _BIT6;
        enumError = WriteMcuRegBit(_MCUREG_57, (BYTE)(~_BIT6), (BYTE)(_BIT6));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Calculate Burst Command
        pData[1] = (BYTE)((usDataLength / _HW_IIC_WRITE_PRE_DATA_LEN) + ((usDataLength % _HW_IIC_WRITE_PRE_DATA_LEN/*GetHwI2CWritePageLength()*/) ? 1 : 0));

        for(pData[2] = 0; pData[2] < pData[1]; pData[2]++)
        {
            // Wait I2C Fifo Clk Switch to Mcu Clk
            enumError = WaitRegForBitChange(_MCUREG_5D, _BIT5, _BIT5, 1500);
            if(enumError != _ERROR_SUCCESS)
            {
                if(enumError == _ERROR_COMMONFUNC_POLLINGFAIL)
                {
                    // Reset(Block) IIC module
                    //MCU_FF55_I2CM_CR0 &= ~_BIT7;
                    WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT7)), 0);

                    // Enable IIC module
                    //MCU_FF55_I2CM_CR0 |= _BIT7;
                    WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT7)), (BYTE)(_BIT7));
                }
                return enumError;
            }

            // Load data to IIC buffer for transmission
            for(ucI = 0; ucI < pData[0]; ucI++)
            {
                enumError = WriteMcuReg(_MCUREG_5E, *pucWriteArray);
                if(enumError != _ERROR_SUCCESS)
                {
                    return enumError;
                }
                pucWriteArray++;
            }

            if(pData[2] != 0)
            {
                // Set data length
                ucTempLength = ((pData[0] - 1) << 1) & (_BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1);
            }

            // Set Length and First Burst Command Start, Must Keep FF55[6] = 1 until Burst Mode end
            //MCU_FF55_I2CM_CR0 = 0xC0 + ucTempLength;
            enumError = WriteMcuReg(_MCUREG_55, 0xC0 + ucTempLength);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }

            // Update Remain Data Length
            usDataLength = usDataLength - pData[0];

            if(usDataLength > _HW_IIC_WRITE_PRE_DATA_LEN)
            {
                pData[0] = _HW_IIC_WRITE_PRE_DATA_LEN;
            }
            else
            {
                pData[0] = (BYTE)usDataLength;
            }

            if(pData[2] == (pData[1] - 1))
            {
                // Disable Burst Write
                //MCU_FF57_I2CM_CR2 &= ~_BIT6;
                enumError = WriteMcuRegBit(_MCUREG_57, (BYTE)(~(_BIT6)), 0);
                if(enumError != _ERROR_SUCCESS)
                {
                    return enumError;
                }

                // Burst write again
                //MCU_FF5D_I2CM_SR |= (_BIT4 | _BIT3);
                enumError = WriteMcuRegBit(_MCUREG_5D, (BYTE)(~(_BIT4 | _BIT3)), (BYTE)(_BIT4 | _BIT3));
                if(enumError != _ERROR_SUCCESS)
                {
                    return enumError;
                }

                break;
            }
            else if(pData[2] != 0)
            {
                // Burst write again
                //MCU_FF5D_I2CM_SR |= (_BIT4 | _BIT3);
                enumError = WriteMcuRegBit(_MCUREG_5D, (BYTE)(~(_BIT4 | _BIT3)), (BYTE)(_BIT4 | _BIT3));
                if(enumError != _ERROR_SUCCESS)
                {
                    return enumError;
                }
            }

            // Wait into Burst Wait State
            enumError = WaitRegForBitChange(_MCUREG_5D, _BIT3, _BIT3, 1500);
            if(enumError != _ERROR_SUCCESS)
            {
                if(enumError == _ERROR_COMMONFUNC_POLLINGFAIL)
                {
                    // Reset(Block) IIC module
                    //MCU_FF55_I2CM_CR0 &= ~_BIT7;
                    WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT7)), 0);

                    // Enable IIC module
                    //MCU_FF55_I2CM_CR0 |= _BIT7;
                    WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT7)), (BYTE)(_BIT7));
                }
                return enumError;
            }
        }
    }

    enumError = WaitRegForBitChange(_MCUREG_5D, _BIT0, _BIT0, 1500);
    if(enumError != _ERROR_SUCCESS)
    {
        if(enumError == _ERROR_COMMONFUNC_POLLINGFAIL)
        {
            // Reset(Block) IIC module
            //MCU_FF55_I2CM_CR0 &= ~_BIT7;
            WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT7)), 0);

            // Enable IIC module
            //MCU_FF55_I2CM_CR0 |= _BIT7;
            WriteMcuRegBit(_MCUREG_55, (BYTE)(~(_BIT7)), (BYTE)(_BIT7));
        }
        return enumError;
    }

    // Clear all flags
    //MCU_FF5D_I2CM_SR |= 0x07;
    enumError = WriteMcuRegBit(_MCUREG_5D, 0xF8, 0x07);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    if(g_enumSpecialCommTypeTmp == _ENUM_SPECIAL_COMM_IICMASTER)
    {
        g_enumSpecialCommType = _ENUM_SPECIAL_COMM_IICMASTER;
        g_enumSpecialCommTypeTmp = _ENUM_SPECIAL_COMM_NORMAL;
    }
    return _ERROR_SUCCESS;
}


void SetCurWorkingPath(TCHAR* pcDirPath)
{
    g_strCurrentDir = pcDirPath;
}

void SetDebugSlave(BYTE ucDebugSlave)
{
    g_ucDebugSlave = ucDebugSlave;
}

void SetIspSlave(BYTE ucIspSlave)
{
    g_ucIspSlave = ucIspSlave;
}

void SetIspContinuousSlave(BYTE ucIspContinuousSlave)
{
    g_ucIspContinuousSlave = ucIspContinuousSlave;
}

BYTE GetDebugSlave()
{
    return g_ucDebugSlave;
}

BYTE GetIspSlave()
{
    return g_ucIspSlave;
}

BYTE GetIspContinuousSlave()
{
    return g_ucIspContinuousSlave;
}

STRUCT_ENUM_ERROR_TYPE SetDebugMode(STRUCT_ENUM_DEBUG_TYPE enumDebugType)
{
    g_enumDebugMode = enumDebugType;
    return _ERROR_SUCCESS;
}

STRUCT_ENUM_DEBUG_TYPE GetDebugMode()
{
    return g_enumDebugMode;
}

STRUCT_ENUM_COMM_ID GetCommID()
{
    if(rsdGetCommID == NULL)
    {
        return _ENUM_COMM_UNKNOWN;
    }
    return rsdGetCommID();
}

WORD GetI2CPageLength()
{
    if(rsdGetI2CPageLength == NULL)
    {
        return 0;
    }
    return rsdGetI2CPageLength();
}
WORD GetNativePageLength()
{
    if(rsdGetNativePageLength == NULL)
    {
        return 0;
    }
    return rsdGetNativePageLength();
}

int GetCommCount()
{
   return g_vectDeviceInfo.size();
}

void GetCommName(TCHAR *pcName)
{
    if(rsdGetCommName == NULL)
    {
        return;
    }
    rsdGetCommName(pcName, _MAX_PATH); 
}

void GetAllCommName(TCHAR pcNames[][256])
{
    unsigned int  i = 0;
    
    for(i = 0; i < g_vectDeviceInfo.size(); i++)
    {
        _tcscpy_s(pcNames[i], g_vectDeviceInfo[i].carrCommName);
    }
}

STRUCT_ENUM_ERROR_TYPE SetCommByID(STRUCT_ENUM_COMM_ID enumCommID)
{
    unsigned int nIndex = 0;
    
	if(g_vectDeviceInfo.size() == 0)
	{
		return _ERROR_COMM_NOTEXIST;
	}

   for(nIndex = 0; nIndex < g_vectDeviceInfo.size(); nIndex++)
    {
        if(g_vectDeviceInfo[nIndex].enumCommID == enumCommID)
        {
            if(!rsdLoadDeviceDllFile((TCHAR *)g_vectDeviceInfo[nIndex].strDllFile.data()))
            {
                return _ERROR_COMM_LOADDLL_FAIL;
            }
            else
            {

                return _ERROR_SUCCESS;
            }
			break;
        }
    }
    return _ERROR_COMM_NOTEXIST;
}

STRUCT_ENUM_ERROR_TYPE SetCommByIndex(WORD usCommIndex)
{
    if((usCommIndex + 1) > (WORD)g_vectDeviceInfo.size())
    {
        return _ERROR_COMM_NOTEXIST;
    }
    else
    {
        if(!rsdLoadDeviceDllFile((TCHAR *)g_vectDeviceInfo[usCommIndex].strDllFile.data()))
        {
            return _ERROR_COMM_LOADDLL_FAIL;
        }       
    }

    return _ERROR_SUCCESS;
}
STRUCT_ENUM_ERROR_TYPE GetCommFile(STRUCT_COMM_INFO *pstCommVer)
{
    unsigned int nIndex = 0;
    if(g_vectDeviceInfo.size() == 0)
    {
        return _ERROR_COMM_NOTEXIST;
    }

    for(nIndex = 0; nIndex < g_vectDeviceInfo.size(); nIndex++)
    {
        _tcscpy_s(pstCommVer[nIndex].strName,  g_vectDeviceInfo[nIndex].carrCommName);
        _tcscpy_s(pstCommVer[nIndex].cszCommFile, g_vectDeviceInfo[nIndex].strDllFile.data());
    }

    return _ERROR_SUCCESS;
}


STRUCT_ENUM_ERROR_TYPE I2CWriteEx(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf, BOOL bAuto)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD i = 0;
    WORD usPageLength = rsdGetI2CPageLength();
    BYTE ucSubAddr = ucSub; 

    if(rsdI2CWrite == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    // Sometime just send slave address and sub address
    if(usLength == 0)
    {
        enumError = I2CWrite(ucSlave, ucSubAddr, 0, NULL);
        return enumError;
    }

    for(i = 0; i < usLength / usPageLength; i++)
    {
        if(bAuto)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = I2CWrite(ucSlave, ucSubAddr, usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        if(bAuto)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = I2CWrite(ucSlave, ucSubAddr, (usLength % usPageLength), pucBuf + (i * usPageLength));
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE I2CWrite(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf)
{
    if(rsdI2CWrite == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    if(g_enumSpecialCommType == _ENUM_SPECIAL_COMM_IICMASTER)
    {
        return I2CMasterWrite(ucSlave, ucSub, 1, pucBuf);
    }
    else
    {
        return rsdI2CWrite(ucSlave, ucSub, usLength, pucBuf);
    }
}

STRUCT_ENUM_ERROR_TYPE I2CWriteByte(BYTE ucSlave, BYTE ucSub, BYTE ucValue)
{
    if(rsdI2CWrite == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    return rsdI2CWrite(ucSlave, ucSub, 1, &ucValue);
}

STRUCT_ENUM_ERROR_TYPE I2CReadEx(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf, BOOL bAuto)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = rsdGetI2CPageLength();
    BYTE ucSubAddr = ucSub;
    if(rsdI2CRead == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    for(i = 0; i < usLength / usPageLength; i++)
    {
        if(bAuto)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = I2CRead(ucSlave, ucSubAddr, usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        if(bAuto)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = I2CRead(ucSlave, ucSubAddr, (usLength % usPageLength), pucBuf + (i * usPageLength));
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE I2CCurrentReadEx(BYTE ucSlave, WORD usLength, LPBYTE pucBuf)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = rsdGetI2CPageLength();

    if(rsdI2CCurrentRead == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    for(i = 0; i < usLength / usPageLength; i++)
    {
        enumError = I2CCurrentRead(ucSlave, usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        enumError = I2CCurrentRead(ucSlave, (usLength % usPageLength), pucBuf + (i * usPageLength));
    }

    return enumError;
}
STRUCT_ENUM_ERROR_TYPE I2CRead(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf)
{
    if(rsdI2CRead == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    if(g_enumSpecialCommType == _ENUM_SPECIAL_COMM_IICMASTER)
    {
        return I2CMasterRead(ucSlave, ucSub, 1, pucBuf);
    }
    else
    {
        return rsdI2CRead(ucSlave, ucSub, usLength, pucBuf);
    }
}

STRUCT_ENUM_ERROR_TYPE I2CWordWriteEx(BYTE ucSlave, WORD usSub, WORD usLength, const LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = rsdGetI2CPageLength();
    WORD usSubAddr = usSub;
    if(rsdI2CWordWrite == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    // Sometime just send slave address and sub address
    if(usLength == 0)
    {
        enumError = I2CWordWrite(ucSlave, usSubAddr, 0, NULL);
        return enumError;
    }

    for(i = 0; i < usLength / usPageLength; i++)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            usSubAddr = (WORD)(usSub + (i * usPageLength));
        }
        else
        {
            usSubAddr = usSub;
        }
        enumError = I2CWordWrite(ucSlave, usSubAddr, usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            usSubAddr = (WORD)(usSub + (i * usPageLength));
        }
        else
        {
            usSubAddr = usSub;
        }
        enumError = I2CWordWrite(ucSlave, usSubAddr, (usLength % usPageLength), pucBuf + (i * usPageLength));
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE I2CWordReadEx(BYTE ucSlave, WORD usSub, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = rsdGetI2CPageLength();
    WORD usSubAddr = usSub;

    if(rsdI2CWordRead == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    for(i = 0; i < usLength / usPageLength; i++)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            usSubAddr = (WORD)(usSub + (i * usPageLength));
        }
        else
        {
            usSubAddr = usSub;
        }
        enumError = I2CWordRead(ucSlave, usSubAddr, usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            usSubAddr = (WORD)(usSub + (i * usPageLength));
        }
        else
        {
            usSubAddr = usSub;
        }
        enumError = I2CWordRead(ucSlave, usSubAddr, (usLength % usPageLength), pucBuf + (i * usPageLength));
    }

    return enumError;
}


STRUCT_ENUM_ERROR_TYPE SetWaitingMode(STRUCT_WAITING_STRUCT stWaitingMode)
{
    if(rsdSetUsbWaitingMode == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    return rsdSetUsbWaitingMode(stWaitingMode);
}

STRUCT_WAITING_STRUCT GetWaitingMode()
{
    STRUCT_WAITING_STRUCT stWaiting ={_WAITING_NONE, 0};
    if(rsdGetWaitingMode == NULL)
    {
        return stWaiting;
    }
    return rsdGetWaitingMode();
}

STRUCT_ENUM_ERROR_TYPE SetAuxMode(STRUCT_AUXMODE_STRUCT stAuxMode)
{
    if(rsdSetAuxMode == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    return rsdSetAuxMode(stAuxMode);
}

STRUCT_ENUM_ERROR_TYPE SetI2CSpeed(WORD usI2cSpeed)
{
    if(rsdSetI2CSpeed == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    return rsdSetI2CSpeed(usI2cSpeed);
}
WORD GetI2CSpeed()
{
    if(rsdGetI2CSpeed == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    return rsdGetI2CSpeed();
}

STRUCT_ENUM_ERROR_TYPE I2CCurrentRead(BYTE ucSlave, WORD usLength, BYTE* pucBuf)
{
    if(rsdI2CCurrentRead == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    if(g_enumSpecialCommType == _ENUM_SPECIAL_COMM_IICMASTER)
    {
        return I2CMasterCurrentRead(ucSlave, usLength, pucBuf);
    }
    else
    {
        return rsdI2CCurrentRead(ucSlave, usLength, pucBuf);
    }
}

STRUCT_ENUM_ERROR_TYPE I2CWordRead(BYTE ucSlave, WORD usSub, WORD usLength, BYTE* pucBuf)
{
    if(rsdI2CWordRead == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    if(g_enumSpecialCommType == _ENUM_SPECIAL_COMM_IICMASTER)
    {
        return I2CMasterWordRead(ucSlave, usSub, usLength, pucBuf);
    }
    else
    {
        return rsdI2CWordRead(ucSlave, usSub, usLength, pucBuf);
    }
}

STRUCT_ENUM_ERROR_TYPE I2CWordWrite(BYTE ucSlave, WORD usSub, WORD usLength, BYTE* pucBuf)
{
    if(rsdI2CWordWrite == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    if(g_enumSpecialCommType == _ENUM_SPECIAL_COMM_IICMASTER)
    {
        return I2CMasterWordWrite(ucSlave, usSub, usLength, pucBuf);
    }
    else
    {
        return rsdI2CWordWrite(ucSlave, usSub, usLength, pucBuf);
    }
}

STRUCT_ENUM_ERROR_TYPE WriteMcuReg(WORD usReg, BYTE ucValue)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucszBuf[2] = {0};
    WORD usDataAdr = 0;

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        usDataAdr = (0xFF << 8) | (usReg & 0xFF);
        return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usDataAdr, FALSE, 1, &ucValue);
    }

    switch(g_enumDebugMode)
    {
    case _DEBUG_ISP:
        enumError = I2CWrite(g_ucIspSlave, (BYTE)usReg, 1, &ucValue);
        break;
    case _DEBUG_DEBUG:
    case _DEBUG_XDATA:
        ucszBuf[0] = 0xFF;
        ucszBuf[1] = (BYTE)usReg;

        enumError = I2CWrite(g_ucDebugSlave, 0x03, 1, &ucValue);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        enumError = I2CWrite(g_ucDebugSlave, 0x01, 1, &ucszBuf[0]);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        enumError = I2CWrite(g_ucDebugSlave, 0x3B, 1, &ucszBuf[1]);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        break;

    case _DEBUG_STEPTRACE:
    default:
        enumError = _ERROR_COMM_UNSUPPORT_DEBUGMODE;
        break;
    }

    return enumError;    
}

STRUCT_ENUM_ERROR_TYPE WriteMcuRegs(WORD usReg, WORD usLength, BYTE *pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    WORD usIndex = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucszBufSend[UC_NEW_XDATA_MAX_LEN + 5] = {0};
    WORD usRegAddr = usReg;

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        usRegAddr = (0xFF << 8) | (usReg & 0xFF);
        if(enumInc == _INCTYPE_AUTO)
        {
            return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usRegAddr, TRUE, usLength, pucBuf);
        }
        else
        {
            return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usRegAddr, FALSE, usLength, pucBuf);
        }
    }

    switch(g_enumDebugMode)
    {
    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex < usLength / UC_NEW_XDATA_MAX_LEN; usIndex++)
        {
            memset(ucszBufSend, 0, sizeof(ucszBufSend));
            if(enumInc == _INCTYPE_AUTO)
            {
                usRegAddr = usReg + usIndex * UC_NEW_XDATA_MAX_LEN;
            }

            enumError = WriteRegNewXdata(usRegAddr, UC_NEW_XDATA_MAX_LEN, pucBuf + usIndex * UC_NEW_XDATA_MAX_LEN, enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }

        if((usLength % UC_NEW_XDATA_MAX_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                usRegAddr = usReg + usIndex * UC_NEW_XDATA_MAX_LEN;
            }
            enumError = WriteRegNewXdata(usRegAddr, (usLength % UC_NEW_XDATA_MAX_LEN), pucBuf + usIndex * UC_NEW_XDATA_MAX_LEN, enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_XDATA:
    case _DEBUG_STEPTRACE:
    default:
        if(enumInc == _INCTYPE_AUTO)
        {
            for(usIndex = 0; usIndex < usLength; usIndex++)
            {
                enumError = WriteMcuReg(usReg + usIndex, *(pucBuf + usIndex));
                if(enumError != _ERROR_SUCCESS)
                {
                    break;
                }
            }
        }
        else
        {
            for(usIndex = 0; usIndex < usLength; usIndex++)
            {
                enumError = WriteMcuReg(usReg, *(pucBuf + usIndex));
                if(enumError != _ERROR_SUCCESS)
                {
                    break;
                }
            }
        }
        break;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadMcuRegs(WORD usReg, WORD usLength, BYTE *pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    WORD usIndex = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usRegAddr = usReg;

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        usRegAddr = (0xFF << 8) | (usReg & 0xFF);
        if(enumInc == _INCTYPE_AUTO)
        {
            return ReceiveUsbPacket(_USB_VENDOR_GET_REGISTER_VALUE, usRegAddr, TRUE, usLength, pucBuf);
        }
        else
        {
            return ReceiveUsbPacket(_USB_VENDOR_GET_REGISTER_VALUE, usRegAddr, FALSE, usLength, pucBuf);
        }
    }


    switch(g_enumDebugMode)
    {
    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex < (usLength / UC_NEW_XDATA_MAX_LEN); usIndex++)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                usRegAddr = usReg + usIndex * UC_NEW_XDATA_MAX_LEN;
            }
            enumError = ReadRegNewXdata(usRegAddr, UC_NEW_XDATA_MAX_LEN, pucBuf + usIndex * UC_NEW_XDATA_MAX_LEN, enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }

        if((usLength % UC_NEW_XDATA_MAX_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                usRegAddr = usReg + usIndex * UC_NEW_XDATA_MAX_LEN;
            }

            enumError = ReadRegNewXdata(usRegAddr, (usLength % UC_NEW_XDATA_MAX_LEN), pucBuf + usIndex * UC_NEW_XDATA_MAX_LEN, enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;

    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_XDATA:
    case _DEBUG_STEPTRACE:
    default:
        if(enumInc == _INCTYPE_AUTO)
        {
            for(usIndex = 0; usIndex < usLength; usIndex++)
            {
                enumError = ReadMcuReg(usReg + usIndex, pucBuf + usIndex);
                if(enumError != _ERROR_SUCCESS)
                {
                    break;
                }
            }
        }
        else
        {
            for(usIndex = 0; usIndex < usLength; usIndex++)
            {
                enumError = ReadMcuReg(usReg, pucBuf + usIndex);
                if(enumError != _ERROR_SUCCESS)
                {
                    break;
                }
            }
        }
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadMcuReg(WORD usReg, BYTE* pucValue)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucszBuf[2] = {0};
    WORD usXDataAdr = 0;

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        usXDataAdr = (0xFF << 8) | (usReg & 0xFF);
        return ReceiveUsbPacket(_USB_VENDOR_GET_REGISTER_VALUE, usXDataAdr, FALSE, 1, pucValue);
    }
    switch(g_enumDebugMode)
    {
    case _DEBUG_ISP:
        enumError = I2CRead(g_ucIspSlave, (BYTE)usReg, 1, pucValue);
        break;

    case _DEBUG_DEBUG:
    case _DEBUG_XDATA:
        ucszBuf[0] = 0xFF;
        ucszBuf[1] = (BYTE)usReg;
        enumError = I2CWriteByte(g_ucDebugSlave, 0x01, ucszBuf[0]);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        enumError = I2CWriteByte(g_ucDebugSlave, 0x3A, ucszBuf[1]);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        enumError = I2CRead(g_ucDebugSlave, 0x08, 1, pucValue);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        break;

    case _DEBUG_STEPTRACE:
        usXDataAdr = (0xFF << 8) | (BYTE)usReg;
        enumError = StepTraceRead(usXDataAdr, pucValue);
        break;

    case _DEBUG_NEW_XDATA:
        usXDataAdr = (0xFF << 8) | (BYTE)usReg;
        enumError = ReadRegNewXdata(usXDataAdr, 1, pucValue, _INCTYPE_NONE);
        break;

    default:
        enumError = _ERROR_COMM_UNSUPPORT_DEBUGMODE;
        break;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteMcuRegBit(WORD usReg, BYTE ucAnd, BYTE ucOr)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucValue = 0;

    enumError = ReadMcuReg(usReg, &ucValue);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    enumError = WriteMcuReg(usReg, (ucValue & ucAnd) | ucOr);

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteContinuousMcuReg(BYTE ucSub, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usRegAddr = 0;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        usRegAddr = (0xFF << 8) | (ucSub & 0xFF);
        if(enumInc == _INCTYPE_AUTO)
        {
            return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usRegAddr, TRUE, usLength, pucBuf);
        }
        else
        {
            return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usRegAddr, FALSE, usLength, pucBuf);
        }
    }

    switch(g_enumDebugMode)
    {
    case _DEBUG_ISP:
        enumError = I2CWriteEx(g_ucIspContinuousSlave, ucSub, usLength, pucBuf, enumInc);
        break;
    case _DEBUG_XDATA:
    case _DEBUG_DEBUG:
    case _DEBUG_NEW_XDATA:
    case _DEBUG_STEPTRACE:
        enumError = WriteMcuRegs(((WORD)0xFF << 8) | ucSub, usLength, pucBuf, enumInc);
        break;

    default:
        enumError = _ERROR_COMM_UNSUPPORT_MCUREGACCESSMODE;
        break;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadContinuousMcuReg(BYTE ucSub, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usRegAddr = 0;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        usRegAddr = (0xFF << 8) | (ucSub & 0xFF);
        if(enumInc == _INCTYPE_AUTO)
        {
            return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usRegAddr, TRUE, usLength, pucBuf);
        }
        else
        {
            return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usRegAddr, FALSE, usLength, pucBuf);
        }
    }

    switch(g_enumDebugMode)
    {
    case _DEBUG_ISP:
        enumError = I2CReadEx(g_ucIspContinuousSlave, ucSub, usLength, pucBuf, enumInc);
        break;
    case _DEBUG_XDATA:
    case _DEBUG_DEBUG:
    case _DEBUG_NEW_XDATA:
    case _DEBUG_STEPTRACE:
        enumError = ReadMcuRegs(((WORD)0xFF << 8) | ucSub, usLength, pucBuf, enumInc);
        break;

    default:
        enumError = _ERROR_COMM_UNSUPPORT_MCUREGACCESSMODE;
        break;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE SendUsbPacket(BYTE bRequest, WORD usValue, WORD usIndex, WORD usLength, void * pData)
{
    if(rsdSendUsbPacket == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
	return rsdSendUsbPacket(bRequest, usValue, usIndex, usLength, pData);

}
STRUCT_ENUM_ERROR_TYPE ReceiveUsbPacket(BYTE bRequest, WORD usValue, WORD usIndex, WORD usLength, void * pData)
{
    if(rsdReceiveUsbPacket == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
	return rsdReceiveUsbPacket(bRequest, usValue, usIndex, usLength, pData);

}


STRUCT_ENUM_ERROR_TYPE AdjustOption()
{
    if(rsdAdjustOption == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    return rsdAdjustOption();
}

STRUCT_ENUM_ERROR_TYPE ReadReg(BYTE ucReg, BYTE* pucValue)
{
    WORD usXdataReg = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        usXdataReg = (((WORD)g_ucCurPage) << 8) | ucReg;
        return ReceiveUsbPacket(_USB_VENDOR_GET_REGISTER_VALUE, usXdataReg, FALSE, 1, pucValue);
    }

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
        enumError = I2CWriteByte(g_ucDebugSlave, 0x41, ucReg);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        // Sub address is ignored here. We can not use I2CCurrentRead because smbus and Aux has 
        // special i2c protocol
        enumError = I2CRead(g_ucDebugSlave, 0x08, 1, pucValue);
        break;

    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        usXdataReg = (((WORD)g_ucCurPage) << 8) | ucReg;
        enumError = ReadRegEx(usXdataReg, pucValue);
        break;

    case _DEBUG_ISP:
        enumError = I2CWriteByte(g_ucIspSlave, 0xF4, ucReg);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = I2CRead(g_ucIspSlave, 0xF5, 1, pucValue);
        break;

    case _DEBUG_STEPTRACE:
        usXdataReg = (((WORD)g_ucCurPage) << 8) | ucReg;
        enumError = StepTraceRead(usXdataReg, pucValue);
        break;

    default:
        enumError = _ERROR_COMM_UNSUPPORT_DEBUGMODE;
        break;
    }

    // Save the current page index
    if(ucReg == UC_PAGESELREG)
    {
        g_ucCurPage = *pucValue;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteReg(BYTE ucReg, BYTE ucValue)
{
    WORD usXdataReg = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        usXdataReg = (((WORD)g_ucCurPage) << 8) | ucReg;
        return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usXdataReg, FALSE, 1, &ucValue);
    }
    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
        enumError = I2CWriteByte(g_ucDebugSlave, 0x01, ucReg);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = I2CWriteByte(g_ucDebugSlave, 0x00, ucValue);
        break;

    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        usXdataReg = (((WORD)g_ucCurPage) << 8) | ucReg;
        enumError = WriteRegEx(usXdataReg, ucValue);
        break;

    case _DEBUG_ISP:
        enumError = I2CWriteByte(g_ucIspSlave, 0xF4, ucReg);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = I2CWriteByte(g_ucIspSlave, 0xF5, ucValue);
        break;

    case _DEBUG_STEPTRACE:
        usXdataReg = (((WORD)g_ucCurPage) << 8) | ucReg;
        enumError = StepTraceWrite(usXdataReg, ucValue);
        break;

    default:
        enumError = _ERROR_COMM_UNSUPPORT_DEBUGMODE;
        break;
    }

    // Save the current page index
    if(ucReg == UC_PAGESELREG)
    {
        g_ucCurPage = ucValue;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadRegs(BYTE ucReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    WORD usIndex = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        WORD usXdataReg = (((WORD)g_ucCurPage) << 8) | ucReg;
        if(enumInc == _INCTYPE_AUTO)
        {
            return ReceiveUsbPacket(_USB_VENDOR_GET_REGISTER_VALUE, usXdataReg, TRUE, usLength, pucBuf);
        }
        else
        {
            return ReceiveUsbPacket(_USB_VENDOR_GET_REGISTER_VALUE, usXdataReg, FALSE, usLength, pucBuf);
        }
    }


    if(enumInc == _INCTYPE_AUTO)
    {
        for(usIndex = 0; usIndex < usLength; usIndex++)
        {
            enumError = ReadReg((BYTE)(ucReg + usIndex), pucBuf + usIndex);
            if(enumError != _ERROR_SUCCESS)
            {
                break;
            }
        }
    }
    else
    {
        for(usIndex = 0; usIndex < usLength; usIndex++)
        {
            enumError = ReadReg(ucReg, pucBuf + usIndex);
            if(enumError != _ERROR_SUCCESS)
            {
                break;
            }
        }
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteRegs(BYTE ucReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    WORD usIndex = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        WORD usXdataReg = (((WORD)g_ucCurPage) << 8) | ucReg;
        if(enumInc == _INCTYPE_AUTO)
        {
            return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usXdataReg, FALSE, usLength, pucBuf);
        }
        else
        {
            return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usXdataReg, TRUE, usLength, pucBuf);
        }
    }

    if(enumInc == _INCTYPE_AUTO)
    {
        for(usIndex = 0; usIndex < usLength; usIndex++)
        {
            enumError = WriteReg((BYTE)(ucReg + usIndex), *(pucBuf + usIndex));
            if(enumError != _ERROR_SUCCESS)
            {
                break;
            }
        }
    }
    else
    {
        for(usIndex = 0; usIndex < usLength; usIndex++)
        {
            enumError = WriteReg(ucReg, *(pucBuf + usIndex));
            if(enumError != _ERROR_SUCCESS)
            {
                break;
            }
        }
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteRegBit(BYTE ucReg, BYTE ucAnd, BYTE ucOr)
{
    BYTE ucValue = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    enumError = ReadReg(ucReg, &ucValue);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    enumError = WriteReg(ucReg, (ucValue & ucAnd) | ucOr);

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WritePortRegBit(BYTE ucAddrReg, BYTE ucDataReg, BYTE ucAnd, BYTE ucOr)
{
    BYTE ucAddr = 0, ucValue = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    enumError = ReadReg(ucAddrReg, &ucAddr);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    enumError = ReadReg(ucDataReg, &ucValue);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    enumError = WriteReg(ucAddrReg, ucAddr);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    enumError = WriteReg(ucDataReg, (ucValue & ucAnd) | ucOr);

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadRegEx(WORD usReg, BYTE* pucValue)
{
    BYTE ucPage = 0x00;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        return ReceiveUsbPacket(_USB_VENDOR_GET_REGISTER_VALUE, usReg, FALSE, 1, pucValue);
    }
    // Select page
    ucPage = (BYTE)((usReg >> 8) & 0x00FF);
    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
        if(ucPage == 0xFF)
        {
            enumError = I2CRead(g_ucIspSlave, (BYTE)usReg, 1, pucValue);
        }
        else
        {
            if((!g_bPageMark) || ((g_bPageMark) && (ucPage != g_ucCurPage)))
            {
                enumError = WriteReg(UC_PAGESELREG, ucPage);
                if(enumError != _ERROR_SUCCESS)
                {
                    return enumError;
                }
                g_bPageMark = TRUE;
            }
            enumError = ReadReg((BYTE)usReg, pucValue);       
        }
        break;

    case _DEBUG_XDATA:
        enumError = I2CWriteByte(g_ucDebugSlave, 0x01, ucPage);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = I2CWriteByte(g_ucDebugSlave, 0x3A, (BYTE)usReg);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = I2CRead(g_ucDebugSlave, 0x08, 1, pucValue);
        g_ucCurPage = ucPage;
        break;

    case _DEBUG_STEPTRACE:
        enumError = StepTraceRead(usReg, pucValue);
        break;

    case _DEBUG_NEW_XDATA: 
        enumError = ReadRegNewXdata(usReg, 1, pucValue, _INCTYPE_NONE);
        break;

    default:
        enumError = _ERROR_COMM_UNSUPPORT_DEBUGMODE;
        break;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteRegEx(WORD usReg, BYTE ucValue)
{
    BYTE ucPage = 0x00;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usReg, FALSE, 1, &ucValue);
    }
    // Select page
    ucPage = (BYTE)((usReg >> 8) & 0x00FF);
    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
        if(ucPage == 0xFF)
        {
            enumError = I2CWriteByte(g_ucIspSlave, (BYTE)usReg, ucValue);
        }
        else
        {
            if((!g_bPageMark) || ((g_bPageMark) && (ucPage != g_ucCurPage)))
            {
                enumError = WriteReg(UC_PAGESELREG, ucPage);
                if(enumError != _ERROR_SUCCESS)
                {
                    return enumError;
                }
                g_bPageMark = TRUE;
            }
            enumError = WriteReg((BYTE)usReg, ucValue);
        }
        break;

    case _DEBUG_XDATA:
        enumError = I2CWriteByte(g_ucDebugSlave, 0x03, ucValue);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = I2CWriteByte(g_ucDebugSlave, 0x01, ucPage);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = I2CWriteByte(g_ucDebugSlave, 0x3B, (BYTE)usReg);
        g_ucCurPage = ucPage;
        break;

    case _DEBUG_NEW_XDATA:
        enumError = WriteRegNewXdata(usReg, 1, &ucValue, _INCTYPE_NONE);
        break;

    case _DEBUG_STEPTRACE:
        enumError = StepTraceWrite(usReg, ucValue);
        break;

    default:
        enumError = _ERROR_COMM_UNSUPPORT_DEBUGMODE;
        break;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadRegsEx(WORD usReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    WORD usIndex = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usRegAddr = usReg;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            return ReceiveUsbPacket(_USB_VENDOR_GET_REGISTER_VALUE, usReg, TRUE, usLength, pucBuf);
        }
        else
        {
            return ReceiveUsbPacket(_USB_VENDOR_GET_REGISTER_VALUE, usReg, FALSE, usLength, pucBuf);
        }
    }
    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_XDATA:
    case _DEBUG_STEPTRACE:
        if(enumInc == _INCTYPE_AUTO)
        {
            for(usIndex = 0; usIndex < usLength; usIndex++)
            {
                enumError = ReadRegEx(usReg + usIndex, pucBuf + usIndex);
                if(enumError != _ERROR_SUCCESS)
                {
                    break;
                }
            } 	
        }
        else
        {
            for(usIndex = 0; usIndex < usLength; usIndex++)
            {
                enumError = ReadRegEx(usReg, pucBuf + usIndex);
                if(enumError != _ERROR_SUCCESS)
                {
                    break;
                }
            }   	
        }
        break;

    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex < (usLength / UC_NEW_XDATA_MAX_LEN); usIndex++)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                usRegAddr = usReg + usIndex * UC_NEW_XDATA_MAX_LEN;
            }

            enumError = ReadRegNewXdata(usRegAddr, UC_NEW_XDATA_MAX_LEN, pucBuf + usIndex * UC_NEW_XDATA_MAX_LEN, enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }

        if((usLength % UC_NEW_XDATA_MAX_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                usRegAddr = usReg + usIndex * UC_NEW_XDATA_MAX_LEN;
            }

            enumError = ReadRegNewXdata(usRegAddr, (usLength % UC_NEW_XDATA_MAX_LEN), pucBuf + usIndex * UC_NEW_XDATA_MAX_LEN, enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }

        }
        break;

    default:
        enumError = _ERROR_COMM_UNSUPPORT_DEBUGMODE;
        break;
    }

    return enumError;
}
STRUCT_ENUM_ERROR_TYPE WriteRegsEx(WORD usReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    WORD usIndex = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usRegAddr = usReg;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usReg, TRUE, usLength, pucBuf);
        }
        else
        {
            return SendUsbPacket(_USB_VENDOR_SET_REGISTER_VALUE, usReg, FALSE, usLength, pucBuf);
        }
    }

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_XDATA:
    case _DEBUG_STEPTRACE:
        if(enumInc == _INCTYPE_AUTO)
        {
            for(usIndex = 0; usIndex < usLength; usIndex++)
            {
                enumError = WriteRegEx(usReg + usIndex, *(pucBuf + usIndex));
                if(enumError != _ERROR_SUCCESS)
                {
                    break;
                }
            }	
        }
        else
        {
            for(usIndex = 0; usIndex < usLength; usIndex++)
            {
                enumError = WriteRegEx(usReg, *(pucBuf + usIndex));
                if(enumError != _ERROR_SUCCESS)
                {
                    break;
                }
            }   	
        }
        break;

    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex < usLength / UC_NEW_XDATA_MAX_LEN; usIndex++)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                usRegAddr = usReg + usIndex * UC_NEW_XDATA_MAX_LEN;
            }

            enumError = WriteRegNewXdata(usRegAddr, (UC_NEW_XDATA_MAX_LEN), pucBuf + usIndex * UC_NEW_XDATA_MAX_LEN, enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }

        if((usLength % UC_NEW_XDATA_MAX_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                usRegAddr = usReg + usIndex * UC_NEW_XDATA_MAX_LEN;
            }
            enumError = WriteRegNewXdata(usRegAddr, (usLength % UC_NEW_XDATA_MAX_LEN), pucBuf + usIndex * UC_NEW_XDATA_MAX_LEN, enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
    default:
        enumError = _ERROR_COMM_UNSUPPORT_DEBUGMODE;
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteRegBitEx(WORD usReg, BYTE ucAnd, BYTE ucOr)
{
    BYTE ucValue = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    enumError = ReadRegEx(usReg, &ucValue);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    enumError = WriteRegEx(usReg, (ucValue & ucAnd) | ucOr);

    return enumError;
}
STRUCT_ENUM_ERROR_TYPE WritePortRegBitEx(WORD usAddrReg, WORD usDataReg, BYTE ucAnd, BYTE ucOr)
{
    BYTE ucAddr = 0, ucValue = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    enumError = ReadRegEx(usAddrReg, &ucAddr);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    enumError = ReadRegEx(usDataReg, &ucValue);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    enumError = WriteRegEx(usAddrReg, ucAddr);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    enumError = WriteRegEx(usDataReg, (ucValue & ucAnd) | ucOr);

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadSysDevice(BYTE ucSlave, BYTE ucSub, BYTE ucLength, LPBYTE pucBuf, STRUCT_ENUM_SYS_DEVICE_CMD_TYPE enumCmdType)
{
    BYTE ucIndex = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usValue = 0;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        if(enumCmdType == _SYS_DEVICE_CMD_SPECIAL_FOR_PINSHARE_VERIFY)
        {
            usValue = (1 << 10) | (1 & 0x03) << 8 | ucSlave;
        }
        else
        {
            usValue = (0 << 10) | (1 & 0x03) << 8 | ucSlave;
        }

        return ReceiveUsbPacket(_USB_VENDOR_READ_SYSEEPROM, usValue, (WORD)ucSub, ucLength, pucBuf);
    }

    for(ucIndex = 0; ucIndex < ucLength; ucIndex++)
    {
        enumError = I2CWriteByte(g_ucDebugSlave, 0x02, ucSlave);
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }

        if(enumCmdType == _SYS_DEVICE_CMD_SPECIAL_FOR_PINSHARE_VERIFY)
        {
            enumError = I2CWriteByte(g_ucDebugSlave, 0x45, ucSub + ucIndex);
        }
        else
        {
            enumError = I2CWriteByte(g_ucDebugSlave, 0x44, ucSub + ucIndex);
        }
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }

        enumError = I2CRead(g_ucDebugSlave, 0x08, 1, pucBuf + ucIndex);
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }
    }

    return enumError;
}
STRUCT_ENUM_ERROR_TYPE WriteSysDevice(BYTE ucSlave, BYTE ucSub, BYTE ucLength, LPBYTE pucBuf, STRUCT_ENUM_SYS_DEVICE_CMD_TYPE enumCmdType)
{
    BYTE ucIndex = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usValue = 0;

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        if(enumCmdType == _SYS_DEVICE_CMD_SPECIAL_FOR_PINSHARE_VERIFY)
        {
            usValue = (1 << 10) | (1 & 0x03) << 8 | ucSlave;
        }
        else
        {
            usValue = (0 << 10) | (1 & 0x03) << 8 | ucSlave;
        }

        return SendUsbPacket(_USB_VENDOR_WRITE_SYSEEPROM, usValue, (WORD)ucSub, ucLength, pucBuf);
    }

    for(ucIndex = 0; ucIndex < ucLength; ucIndex++)
    {
        enumError = I2CWriteByte(g_ucDebugSlave, 0x02, ucSlave);
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }

        enumError = I2CWriteByte(g_ucDebugSlave, 0x03, *(pucBuf + ucIndex));
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }

        if(enumCmdType == _SYS_DEVICE_CMD_SPECIAL_FOR_PINSHARE_VERIFY)
        {
            enumError = I2CWriteByte(g_ucDebugSlave, 0x0F, ucSub + ucIndex);
        }
        else
        {
            enumError = I2CWriteByte(g_ucDebugSlave, 0x04, ucSub + ucIndex);
        }
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }
    }

    return enumError;
}
STRUCT_ENUM_ERROR_TYPE ReadWordSysDevice(BYTE ucSlave, WORD usSub, BYTE ucLength, LPBYTE pucBuf, STRUCT_ENUM_SYS_DEVICE_CMD_TYPE enumCmdType)
{
    BYTE ucIndex = 0, ucSub1 = 0, ucSub2 = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usValue = 0;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        if(enumCmdType == _SYS_DEVICE_CMD_SPECIAL_FOR_PINSHARE_VERIFY)
        {
            usValue = (1 << 10) | (2 & 0x03) << 8 | ucSlave;
        }
        else
        {
            usValue = (0 << 10) | (2 & 0x03) << 8 | ucSlave;
        }

        return ReceiveUsbPacket(_USB_VENDOR_READ_SYSEEPROM, usValue, usSub, ucLength, pucBuf);
    }

    for(ucIndex = 0; ucIndex < ucLength; ucIndex++)
    {
        ucSub1 = (BYTE)(((usSub + ucIndex) >> 8) & 0x00FF);
        ucSub2 = (BYTE)((usSub + ucIndex) & 0x00FF);

        enumError = I2CWriteByte(g_ucDebugSlave, 0x02, ucSlave);
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }

        enumError = I2CWriteByte(g_ucDebugSlave, 0x05, ucSub1);
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }

        if(enumCmdType == _SYS_DEVICE_CMD_SPECIAL_FOR_PINSHARE_VERIFY)
        {
            enumError = I2CWriteByte(g_ucDebugSlave, 0x45, ucSub2);
        }
        else
        {
            enumError = I2CWriteByte(g_ucDebugSlave, 0x44, ucSub2);
        }
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }

        enumError = I2CRead(g_ucDebugSlave, 0x08, 1, pucBuf + ucIndex);
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteWordSysDevice(BYTE ucSlave, WORD usSub, BYTE ucLength, LPBYTE pucBuf, STRUCT_ENUM_SYS_DEVICE_CMD_TYPE enumCmdType)
{
    BYTE ucIndex = 0, ucSub1 = 0, ucSub2 = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usValue = 0;

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        if(enumCmdType == _SYS_DEVICE_CMD_SPECIAL_FOR_PINSHARE_VERIFY)
        {
            usValue = (1 << 10) | (2 & 0x03) << 8 | ucSlave;
        }
        else
        {
            usValue = (0 << 10) | (2 & 0x03) << 8 | ucSlave;
        }

        return SendUsbPacket(_USB_VENDOR_WRITE_SYSEEPROM, usValue, usSub, ucLength, pucBuf);
    }

    for(ucIndex = 0; ucIndex < ucLength; ucIndex++)
    {
        ucSub1 = (BYTE)(((usSub + ucIndex) >> 8) & 0x00FF);
        ucSub2 = (BYTE)((usSub + ucIndex) & 0x00FF);

        enumError = I2CWriteByte(g_ucDebugSlave, 0x02, ucSlave);
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }

        enumError = I2CWriteByte(g_ucDebugSlave, 0x03, *(pucBuf + ucIndex));
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }

        enumError = I2CWriteByte(g_ucDebugSlave, 0x05, ucSub1);
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }
        if(enumCmdType == _SYS_DEVICE_CMD_SPECIAL_FOR_PINSHARE_VERIFY)
        {
            enumError = I2CWriteByte(g_ucDebugSlave, 0x0F, ucSub2);
        }
        else
        {
            enumError = I2CWriteByte(g_ucDebugSlave, 0x04, ucSub2);
        }
        if(enumError != _ERROR_SUCCESS)
        {
            break;
        }
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ScalerStop()
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucValue = 0;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        return SendUsbPacket(_USB_VENDOR_ISP_ENABLE, 1, 0, 0, &ucValue);
    }
    // Clear current page index
    g_bPageMark = FALSE;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        enumError = I2CWriteByte(g_ucDebugSlave, 0x80, 0x01);
        break;

    case _DEBUG_ISP:
        enumError = I2CRead(g_ucIspSlave, 0x6F, 1, &ucValue);
        if(enumError != _ERROR_SUCCESS)
        {
            g_bNeedAutoDetectSlave = TRUE;
            g_ucAutoDetectSlaveCount = 0;
            g_ucOldISPSalve = 0x00;
            return enumError;
        }
        enumError = I2CWriteByte(g_ucIspSlave, 0x6F, ucValue | _BIT7);
        break;

    case _DEBUG_STEPTRACE:
        // do no thing
        break;

    default:
        enumError = _ERROR_COMM_UNSUPPORT_DEBUGMODE;
        break;
    }

    if(enumError != _ERROR_SUCCESS)
    {
        g_bNeedAutoDetectSlave = TRUE;
        g_ucAutoDetectSlaveCount = 0;
        g_ucOldISPSalve = 0x00;
        g_bPageMark = FALSE;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ScalerRun()
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    // Clear current page index
    g_bPageMark = FALSE;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        return SendUsbPacket(_USB_VENDOR_ISP_ENABLE, 0, 0, 0, NULL);
    }
    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        enumError = I2CWriteByte(g_ucDebugSlave, 0x80, 0x00);
        break;

    case _DEBUG_ISP:
        //after reset MCU, IC Will not Send ACK, so we don't care return value.
        I2CWriteByte(g_ucIspSlave, 0xEE, 0x02);
        enumError = _ERROR_SUCCESS;
        break;

    case _DEBUG_STEPTRACE:
        // do nothing
        break;
    default:
        enumError = _ERROR_COMM_UNSUPPORT_DEBUGMODE;
        break;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE EnterIspMode(WORD usRetryTimes)
{
    WORD usCount = 0;
    BYTE ucValue = 0;
    STRUCT_ENUM_ERROR_TYPE enumError;

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        return SendUsbPacket(_USB_VENDOR_ISP_ENABLE, 1, 0, 0, &ucValue);
    }

    // Clear current page index
    g_bPageMark = FALSE;

    while(usCount < usRetryTimes)
    {
        enumError = WriteMcuReg(_MCUREG_6F, 0x80);
        if(enumError != _ERROR_SUCCESS)
        {
            g_bNeedAutoDetectSlave = TRUE;
            g_ucAutoDetectSlaveCount = 0;
            g_ucOldISPSalve = 0x00;
            return enumError;
        }

        enumError = ReadMcuReg(_MCUREG_6F, &ucValue);
        if(enumError != _ERROR_SUCCESS)
        {
            g_bNeedAutoDetectSlave = TRUE;
            g_ucAutoDetectSlaveCount = 0;
            g_ucOldISPSalve = 0x00;
            return enumError;
        }

        if((ucValue & _BIT7) == _BIT7)
        {
            return _ERROR_SUCCESS;
        }

        Sleep(1);
        usCount++;
    }

    return _ERROR_COMM_ENTER_ISP_MODE;
}

STRUCT_ENUM_ERROR_TYPE InitialDev()
{
    if(rsdInitialDev == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    return rsdInitialDev();
}

STRUCT_ENUM_ERROR_TYPE ReleaseDev()
{
    if(rsdReleaseDev == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    return rsdReleaseDev();
}

void * GetDeviceHandler()
{
    if(rsdGetDeviceHandler == NULL)
    {
        return NULL;
    }

    return rsdGetDeviceHandler();
}

STRUCT_ENUM_ERROR_TYPE ResetFirmware()
{
    if(rsdResetFirmware == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    return rsdResetFirmware();
}

BYTE GetDeviceCount()
{
    if(rsdGetDeviceCount == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    return rsdGetDeviceCount();
}
STRUCT_ENUM_ERROR_TYPE RemoveDevice()
{
    if(rsdRemoveDevice == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    return rsdRemoveDevice();
}

STRUCT_ENUM_ERROR_TYPE AutoDetectSlaveAddr()
{
    BYTE ucValue = 0;
    BOOL bCheckAck = FALSE;
    WORD usIndex = 0;

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        return _ERROR_SUCCESS;
    }
    if(rsdI2CRead == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    if(!g_bNeedAutoDetectSlave)
    {
        return _ERROR_SUCCESS;
    }
    if(rsdGetCommID() == _ENUM_COMM_FTDIUSB)
    {
        bCheckAck = rsdGetFTDIGetAckStatus();
        rsdSetFTDIGetAck(TRUE);
    }

    for(usIndex = 0; usIndex < US_SCALER_SLAVE_ADDR_GROUP_COUNT; usIndex++)
    {
        if(I2CRead(ST_SCALER_SLAVE_ADRR[usIndex].ucIspSlave, 0x23, 1, &ucValue) == _ERROR_SUCCESS)
        {
            g_ucDebugSlave = ST_SCALER_SLAVE_ADRR[usIndex].ucDebugSlave;
            g_ucIspSlave = ST_SCALER_SLAVE_ADRR[usIndex].ucIspSlave;
            g_ucIspContinuousSlave = ST_SCALER_SLAVE_ADRR[usIndex].ucIspContinuousSlave;
            break;
        }
    }
    if(usIndex >= US_SCALER_SLAVE_ADDR_GROUP_COUNT)
    {
        g_bNeedAutoDetectSlave = TRUE;
        g_ucAutoDetectSlaveCount = 0;
        g_ucOldISPSalve = 0x00;
        if(rsdGetCommID() == _ENUM_COMM_FTDIUSB)
        {
            rsdSetFTDIGetAck(bCheckAck);
        }
        return _ERROR_COMM_AUTO_DETECT_SLAVE_ADDRESS_FAIL;
    }
    if(g_ucOldISPSalve != g_ucIspSlave)
    {
        g_ucOldISPSalve = g_ucIspSlave;
    }
    else
    {
        g_ucAutoDetectSlaveCount++;
    }
    if(g_ucAutoDetectSlaveCount >= UC_AUTO_DETECT_SLAVE_ADDR_TIME)
    {
        g_bNeedAutoDetectSlave = FALSE;
    }
    if(rsdGetCommID() == _ENUM_COMM_FTDIUSB)
    {
        rsdSetFTDIGetAck(bCheckAck);
    }
    return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE DDCCIWrite(BYTE ucSlave, BYTE ucSub, BYTE ucLength, const LPBYTE pucBuf)
{
    BYTE ucWiteBuf[256 + 4] = {0};
    INT i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        return _ERROR_COMM_TYPECUSB_NOT_SUPPORT;
    }
    memset(ucWiteBuf, 0, sizeof(ucWiteBuf));

    ucWiteBuf[0] = ucSlave;
    ucWiteBuf[1] = ucSub;
    ucWiteBuf[2] = (BYTE)(ucLength) | 0x80;

    for(i = 0; i < ucLength; i++)
    {
        ucWiteBuf[i + 3] = pucBuf[i];
    }

    for(i = 0; i < (ucLength + 3); i++)
    {
        ucWiteBuf[3 + ucLength] ^= ucWiteBuf[i];
    }
    enumError = I2CWriteEx(ucSlave, ucSub, ucLength + 2, ucWiteBuf + 2, _INCTYPE_NONE);
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE DDCCIRead(BYTE ucSlave, BYTE ucSub, BYTE ucLength, LPBYTE pucBuf)
{
    BYTE ucReadBuf[256] ={0};
    INT i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucChecksum = 0x50;

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        return _ERROR_COMM_TYPECUSB_NOT_SUPPORT;
    }
    memset(ucReadBuf, 0, sizeof(ucReadBuf));

    enumError = I2CReadEx(ucSlave, ucSub, ucLength, ucReadBuf, _INCTYPE_NONE);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    if (ucReadBuf[0] == ucSlave)
    {
        for (i = 0; i < ((ucReadBuf[1] & 0x7F) + 2); i++)
        {
            ucChecksum ^= ucReadBuf[i];
        }
        if(ucChecksum == ucReadBuf[(ucReadBuf[1] & 0x7F) + 2])
        {
            for(i = 0; i < (ucReadBuf[1] & 0x7f) + 3; i++)
            {
                *(pucBuf + i) = ucReadBuf[i];
            }
            return _ERROR_SUCCESS;
        }
        else
        {
            return _ERROR_COMM_DDCCI_READ_CHECKSUM_ERROR;
        }
    }
    else
    {
        return _ERROR_COMM_DDCCI_READ_SLAVE_ADDRESS;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE SetFTDIGetAck(BOOL bEnable)
{
    if(rsdSetFTDIGetAck == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    return rsdSetFTDIGetAck(bEnable);

}

BOOL GetFTDIGetAckStatus()
{
    if(rsdGetFTDIGetAckStatus == NULL)
    {
        return FALSE;
    }
    return rsdGetFTDIGetAckStatus();

}
STRUCT_ENUM_ERROR_TYPE GetUsbDevicePath(BYTE ucIndex, TCHAR* pcszDevicePath)
{
    if(rsdGetUsbDevicePath == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    return rsdGetUsbDevicePath(ucIndex, pcszDevicePath);

}
STRUCT_ENUM_ERROR_TYPE SelectUsbByDevicePath(TCHAR* pcszDevicePath)
{
    if(rsdSelectUsbByDevicePath == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    return rsdSelectUsbByDevicePath(pcszDevicePath);

}
STRUCT_ENUM_ERROR_TYPE SelectUsbByIndex(BYTE ucIndex)
{
    if(rsdSelectUsbByIndex == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    return rsdSelectUsbByIndex(ucIndex);
}

STRUCT_ENUM_ERROR_TYPE I2CMasterInitial(STRUCT_ENUM_IIC_MASTER_SPEED enumI2cMasterSpeed)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucTOR = 0, ucStaSugpioC = 0, ucSLPC = 0, ucSHPC = 0;
    BYTE ucFD10_14318K = 1;

    switch(enumI2cMasterSpeed)
    {
    case _ENUM_IIC_MASTER_SPEED_100K:
        ucSLPC = 0x26;
        ucSHPC = 0x22;
        ucStaSugpioC = 0x36;
        ucTOR = 0x47;
        ucFD10_14318K = 1;
        break;
    case _ENUM_IIC_MASTER_SPEED_400K:
        ucSLPC = 0x0C;
        ucSHPC = 0x04;
        ucStaSugpioC = 0x09;
        ucTOR = 0x23;
        ucFD10_14318K = 1;
        break;
    case _ENUM_IIC_MASTER_SPEED_100K_TRANS:
        ucSLPC = 0x31;
        ucSHPC = 0x2E;
        ucStaSugpioC = 0x40;
        ucTOR = 0x80;
        ucFD10_14318K = 2;
        break;
    case _ENUM_IIC_MASTER_SPEED_75K_TRANS:
        ucSLPC = 0x38;
        ucSHPC = 0x3B;
        ucStaSugpioC = 0x36;
        ucTOR = 0x80;
        ucFD10_14318K = 2;
        break;
    case _ENUM_IIC_MASTER_SPEED_45K_TRANS:
        ucSLPC = 0x75;
        ucSHPC = 0x4E;
        ucStaSugpioC = 0x80;
        ucTOR = 0xF0;
        ucFD10_14318K = 2;
        break;
    default:
        ucSLPC = 0x26;
        ucSHPC = 0x22;
        ucStaSugpioC = 0x36;
        ucTOR = 0x47;
        ucFD10_14318K = 1;
        break;
    }

    enumError = WriteMcuRegBit(_MCUREG_F2, (BYTE)(~_BIT7), 0);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // Reset IIC module
    //MCU_FF55_I2CM_CR0 &= ~_BIT7;
    enumError = WriteMcuRegBit(_MCUREG_55, (BYTE)(~_BIT7), 0);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // Enable IIC module and disable TOR
    //MCU_FF55_I2CM_CR0 |= _BIT7;
    //MCU_FF55_I2CM_CR0 &= ~_BIT0;
    enumError = WriteMcuRegBit(_MCUREG_55, 0x7E, 0x80);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // Set TOR: time-out = TOR x 2 x ((FD10+1)/input clk)
    //MCU_FF56_I2CM_CR1 = _HW_IIC_TOR;
    enumError = WriteMcuReg(_MCUREG_56, ucTOR);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // Disable burst mode
    //MCU_FF57_I2CM_CR2 = 0x00;
    enumError = WriteMcuReg(_MCUREG_57, 0x00);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // Clear interrupts
    //MCU_FF58_I2CM_CR3 = 0x00;
    enumError = WriteMcuReg(_MCUREG_58, 0x00);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // Set fall time period count
    //MCU_FF59_I2CM_STR0 = _HW_IIC_FTPC;
    enumError = WriteMcuReg(_MCUREG_59, _HW_IIC_FTPC);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // Set STA setup time period count
    //MCU_FF5A_I2CM_STR1 = _HW_IIC_STA_SUGPIO_C;
    enumError = WriteMcuReg(_MCUREG_5A, ucStaSugpioC);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // Set SCL high period count
    //MCU_FF5B_I2CM_STR2 = _HW_IIC_SHPC_14318K;
    enumError = WriteMcuReg(_MCUREG_5B, ucSHPC);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // Set SCL low period count
    //MCU_FF5C_I2CM_STR3 = _HW_IIC_SLPC_14318K;
    enumError = WriteMcuReg(_MCUREG_5C, ucSLPC);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // Set frequency divisor: ref = xtal/(FD10+1)
    //MCU_FF5F_I2CM_CCR = _HW_IIC_FD10_14318K;
    enumError = WriteMcuReg(_MCUREG_5F, ucFD10_14318K);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    return _ERROR_SUCCESS;
}
STRUCT_ENUM_ERROR_TYPE I2CMasterCurrentRead(BYTE ucSlave, WORD usLength, LPBYTE pucBuf)
{
    if(usLength > GetHwI2CReadPageLength())
    {
        return _ERROR_COMM_I2C_MASTER_BUFFER_SIZE;
    }

    return ScalerMcuHwIICRead(ucSlave, _SUBADDR_CURRENT, 0, (BYTE)usLength, pucBuf);

}
STRUCT_ENUM_ERROR_TYPE I2CMasterCurrentReadEx(BYTE ucSlave, WORD usLength, LPBYTE pucBuf,  STRUCT_ENUM_INC_TYPE enumInc)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = GetHwI2CReadPageLength();

    for(i = 0; i < usLength / usPageLength; i++)
    {
        enumError = I2CMasterCurrentRead(ucSlave, (BYTE)usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        enumError = I2CMasterCurrentRead(ucSlave, (BYTE)(usLength % usPageLength), pucBuf + (i * usPageLength));
    }

    return enumError;
}
STRUCT_ENUM_ERROR_TYPE I2CMasterRead(BYTE ucSlave, BYTE ucSub, WORD usLength, LPBYTE pucBuf)
{
    if(usLength > GetHwI2CReadPageLength())
    {
        return _ERROR_COMM_I2C_MASTER_BUFFER_SIZE;
    }
    return ScalerMcuHwIICRead(ucSlave, _SUBADDR_BYTE, ucSub, (BYTE)usLength, pucBuf);
}
STRUCT_ENUM_ERROR_TYPE I2CMasterReadEx(BYTE ucSlave, BYTE ucSub, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = GetHwI2CReadPageLength();
    DWORD ulSmbusDataType = _ENUM_SMBUS_DATA_TYPE_UNKNOWN;
    BYTE ucSubAddr = ucSub;

    // IC don't support SMBUS Block read function(slave ,sub, length, data...)
    if(_ENUM_COMM_SMBUS == rsdGetCommID())
    {
        ulSmbusDataType = rsdGetSMBUSDataType();
        if((ulSmbusDataType & _ENUM_SMBUS_BLOCK_DATA_TYPE_READ) == _ENUM_SMBUS_BLOCK_DATA_TYPE_READ)
        {
            usPageLength = GetHwI2CReadPageLength();
        }
        else
        {
            usPageLength = 2;
        }
    }
    for(i = 0; i < usLength / usPageLength; i++)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = I2CMasterRead(ucSlave, ucSubAddr, (BYTE)usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = I2CMasterRead(ucSlave, ucSubAddr, (BYTE)(usLength % usPageLength), pucBuf + (i * usPageLength));
    }

    return enumError;
}
STRUCT_ENUM_ERROR_TYPE I2CMasterWordRead(BYTE ucSlave, WORD usSub, WORD usLength, LPBYTE pucBuf)
{
    if(usLength > GetHwI2CReadPageLength())
    {
        return _ERROR_COMM_I2C_MASTER_BUFFER_SIZE;
    }

    return ScalerMcuHwIICRead(ucSlave, _SUBADDR_WORD, usSub, (BYTE)usLength, pucBuf);

}
STRUCT_ENUM_ERROR_TYPE I2CMasterWordReadEx(BYTE ucSlave, WORD usSub, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = GetHwI2CReadPageLength();
    WORD usSubAddr = usSub;

    for(i = 0; i < usLength / usPageLength; i++)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            usSubAddr = (WORD)(usSub + (i * usPageLength));
        }
        else
        {
            usSubAddr = usSub;
        }
        enumError = I2CMasterWordRead(ucSlave, usSubAddr, (BYTE)usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            usSubAddr = (WORD)(usSub + (i * usPageLength));
        }
        else
        {
            usSubAddr = usSub;
        }
        enumError = I2CMasterWordRead(ucSlave, usSubAddr, (BYTE)(usLength % usPageLength), pucBuf + (i * usPageLength));
    }

    return enumError;
}
STRUCT_ENUM_ERROR_TYPE I2CMasterCurrentWrite(BYTE ucSlave, WORD usLength, const LPBYTE pucBuf)
{
    return ScalerMcuHwIICWrite(ucSlave, _SUBADDR_CURRENT, 0, usLength, pucBuf);
}
STRUCT_ENUM_ERROR_TYPE I2CMasterCurrentWriteEx(BYTE ucSlave, WORD usLength, const LPBYTE pucBuf)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = GetHwI2CWritePageLength();
    DWORD ulSmbusDataType = _ENUM_SMBUS_DATA_TYPE_UNKNOWN;

    if(_ENUM_COMM_SMBUS == rsdGetCommID())
    {
        ulSmbusDataType = rsdGetSMBUSDataType();
        if((ulSmbusDataType & _ENUM_SMBUS_BLOCK_DATA_TYPE) == _ENUM_SMBUS_BLOCK_DATA_TYPE)
        {
            usPageLength = GetHwI2CWritePageLength();
        }
        else
        {
            usPageLength = 2;
        }
    }

    for(i = 0; i < usLength / usPageLength; i++)
    {
        enumError = I2CMasterCurrentWrite(ucSlave, usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        enumError = I2CMasterCurrentWrite(ucSlave, (usLength % usPageLength), pucBuf + (i * usPageLength));
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE I2CMasterWrite(BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf)
{
    return ScalerMcuHwIICWrite(ucSlave, _SUBADDR_BYTE, ucSub, usLength, pucBuf);
}
    

STRUCT_ENUM_ERROR_TYPE I2CMasterWriteByte(BYTE ucSlave, BYTE ucSub, BYTE ucValue)
{
    return ScalerMcuHwIICWrite(ucSlave, _SUBADDR_BYTE, ucSub, 1, &ucValue);
}

STRUCT_ENUM_ERROR_TYPE I2CMasterWriteEx(BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = GetHwI2CWritePageLength();
    BYTE ucSubAddr = ucSub; 
    DWORD ulSmbusDataType = _ENUM_SMBUS_DATA_TYPE_UNKNOWN;

    if(_ENUM_COMM_SMBUS == rsdGetCommID())
    {
        ulSmbusDataType = rsdGetSMBUSDataType();
        if((ulSmbusDataType & _ENUM_SMBUS_BLOCK_DATA_TYPE) == _ENUM_SMBUS_BLOCK_DATA_TYPE)
        {
            usPageLength = GetHwI2CWritePageLength();
        }
        else
        {
            usPageLength = 2;
        }
    }

    // Sometime just send slave address and sub address
    if(usLength == 0)
    {
        enumError = I2CMasterCurrentWriteEx(ucSlave, usLength, pucBuf);
        return enumError;
    }

    for(i = 0; i < usLength / usPageLength; i++)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = I2CMasterWrite(ucSlave, ucSubAddr, usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = I2CMasterWrite(ucSlave, ucSubAddr, (usLength % usPageLength), pucBuf + (i * usPageLength));
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE I2CMasterWordWrite(BYTE ucSlave, WORD usSub, WORD usLength, const LPBYTE pucBuf)
{
    return ScalerMcuHwIICWrite(ucSlave, _SUBADDR_WORD, usSub, usLength, pucBuf);

}

STRUCT_ENUM_ERROR_TYPE I2CMasterWordWriteEx(BYTE ucSlave, WORD usSub, WORD usLength, const LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = GetHwI2CWritePageLength();
    WORD usSubAddr = usSub;

    // Sometime just send slave address and sub address
    if(usLength == 0)
    {
        enumError = I2CMasterCurrentWriteEx(ucSlave, usLength, pucBuf);
        return enumError;
    }

    for(i = 0; i < usLength / usPageLength; i++)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            usSubAddr = (WORD)(usSub + (i * usPageLength));
        }
        else
        {
            usSubAddr = usSub;
        }
        enumError = I2CMasterWordWrite(ucSlave, usSubAddr, usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            usSubAddr = (WORD)(usSub + (i * usPageLength));
        }
        else
        {
            usSubAddr = usSub;
        }
        enumError = I2CMasterWordWrite(ucSlave, usSubAddr, (usLength % usPageLength), pucBuf + (i * usPageLength));
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteFlashData(DWORD ulFlashAddr, WORD usLen, LPBYTE pucBuf)
{
    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        return SendUsbPacket(_USB_VENDOR_WRITE_TO_FLASH, (ulFlashAddr & 0xFFFF0000) >> 16, (ulFlashAddr & 0xFFFF), usLen, pucBuf);
    }

    return _ERROR_COMM_NOT_SUPPORT;
}
STRUCT_ENUM_ERROR_TYPE ReadFlashData(DWORD ulFlashAddr, WORD usLen, LPBYTE pucBuf)
{

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        return ReceiveUsbPacket(_USB_VENDOR_READ_FROM_FLASH, (ulFlashAddr & 0xFFFF0000) >> 16, (ulFlashAddr & 0xFFFF), usLen, pucBuf);
    }

    return _ERROR_COMM_NOT_SUPPORT;

}
STRUCT_ENUM_ERROR_TYPE I2CWriteSegment(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf)
{

    if(rsdI2CWriteSegment == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    return rsdI2CWriteSegment(ucSegSlave, ucSegAddr, ucSlave, ucSub, usLength, pucBuf);
}

STRUCT_ENUM_ERROR_TYPE I2CWriteSegmentEx(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = rsdGetI2CPageLength();
    BYTE ucSubAddr = ucSub;
    if(rsdI2CWriteSegment == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    for(i = 0; i < usLength / usPageLength; i++)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = rsdI2CWriteSegment(ucSegSlave, ucSegAddr, ucSlave, ucSubAddr, usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = rsdI2CWriteSegment(ucSegSlave, ucSegAddr, ucSlave, ucSubAddr, (usLength % usPageLength), pucBuf + (i * usPageLength));
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE I2CReadSegment(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf)
{
    if(rsdI2CReadSegment == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    return rsdI2CReadSegment(ucSegSlave, ucSegAddr, ucSlave, ucSub, usLength, pucBuf);
}

STRUCT_ENUM_ERROR_TYPE I2CReadSegmentEx(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    int i = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usPageLength = rsdGetI2CPageLength();
    BYTE ucSubAddr = ucSub;
    if(rsdI2CWriteSegment == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    for(i = 0; i < usLength / usPageLength; i++)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = rsdI2CReadSegment(ucSegSlave, ucSegAddr, ucSlave, ucSubAddr, usPageLength, pucBuf + (i * usPageLength));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
    }

    if((usLength % usPageLength) != 0)
    {
        if(enumInc == _INCTYPE_AUTO)
        {
            ucSubAddr = (BYTE)(ucSub + (i * usPageLength));
        }
        else
        {
            ucSubAddr = ucSub;
        }
        enumError = rsdI2CReadSegment(ucSegSlave, ucSegAddr, ucSlave, ucSubAddr, (usLength % usPageLength), pucBuf + (i * usPageLength));
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE NativeWrite(INT nAddress, WORD usLength, const LPBYTE pucBuf)
{
    if(rsdNativeWrite == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    return rsdNativeWrite(nAddress, usLength, pucBuf);    
}

STRUCT_ENUM_ERROR_TYPE NativeRead(INT nAddress, WORD usLength, LPBYTE pucBuf)
{
    if(rsdNativeRead == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    return rsdNativeRead(nAddress, usLength, pucBuf);    
}

void SetSettingFilePath(TCHAR *pcConfigFilePath)
{
    g_cpstrConfigPath = pcConfigFilePath;
}

DWORD GetSMBUSDataType()
{
    if(rsdGetSMBUSDataType == NULL)
    {
        return _ENUM_SMBUS_DATA_TYPE_UNKNOWN;
    }

    return rsdGetSMBUSDataType();
}
STRUCT_ENUM_ERROR_TYPE SetSMBUSDataType(DWORD ulSMBUSDataType)
{
    if(rsdSetSMBUSDataType == NULL)
    {
        return _ERROR_COMM_NO_INITIAL;
    }

    return rsdSetSMBUSDataType(ulSMBUSDataType);
}
void SetCmdLine(TCHAR *pcCmd)
{
    g_cpstrCmd = pcCmd;
}

STRUCT_ENUM_ERROR_TYPE ReadRegNewXdata(WORD usReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    BYTE ucszBufSend[UC_NEW_XDATA_MAX_LEN + 5] ={0};
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucChecksum = 0;

    if(usLength > UC_NEW_XDATA_MAX_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    ucszBufSend[0] = (BYTE)((usReg & 0xFF00) >> 8);
    ucszBufSend[1] = (BYTE)(usReg & 0x00FF);
    ucszBufSend[2] = (BYTE)usLength;
    if(enumInc == _INCTYPE_AUTO)
    {
        ucszBufSend[3] = TRUE;
    }
    else
    {
        ucszBufSend[3] = FALSE;
    }
    ucChecksum = 0;
    for(int i = 0; i < 4; i++)
    {
        ucChecksum += ucszBufSend[i];
    }
    ucszBufSend[4] = ucChecksum;

    enumError = I2CWrite(g_ucDebugSlave, _SCALER_READ_16BITSREGISTERS_CMD, 5, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    memset(ucszBufSend, 0, sizeof(ucszBufSend));
    enumError = I2CRead(g_ucDebugSlave, _SCALER_USELESS_READ_CMD, usLength + 3, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    ucChecksum = 0;
    if(_SCALER_READ_16BITSREGISTERS_CMD != ucszBufSend[0])
    {
        return _ERROR_COMM_RW_REG_COMMAND;
    }

    if(usLength != ucszBufSend[1])
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }

    for(int i = 0; i < usLength; i++)
    {
        ucChecksum += ucszBufSend[i + 2];
    }
    if(ucChecksum != ucszBufSend[usLength + 2])
    {
        return _ERROR_COMM_RW_REG_CHECKSUM;
    }
    memcpy(pucBuf, ucszBufSend + 2, usLength * sizeof(BYTE));

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteRegNewXdata(WORD usReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    BYTE ucszBufSend[UC_NEW_XDATA_MAX_LEN + 6] ={0};
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucChecksum = 0;
    if(usLength > UC_NEW_XDATA_MAX_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    memset(ucszBufSend, 0, sizeof(ucszBufSend));
    if(enumInc == _INCTYPE_AUTO)
    {
        ucszBufSend[3] = TRUE;
    }
    else
    {
        ucszBufSend[3] = FALSE;
    }
    ucszBufSend[0] = (BYTE)((usReg & 0xFF00) >> 8);
    ucszBufSend[1] = (BYTE)(usReg & 0x00FF);
    ucszBufSend[2] = (BYTE)usLength;
    memcpy(ucszBufSend + 4, pucBuf, sizeof(BYTE) * usLength);
    ucChecksum = 0;
    for(WORD i = 0; i < (usLength + 4); i++)
    {
        ucChecksum += ucszBufSend[i];
    }

    ucszBufSend[usLength + 4] = ucChecksum;
    enumError = I2CWrite(g_ucDebugSlave, _SCALER_WTITE_16BITSREGISTERS_CMD, 5 + usLength, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    memset(ucszBufSend, 0, sizeof(ucszBufSend));
    enumError = I2CRead(g_ucDebugSlave, _SCALER_USELESS_READ_CMD, 2, ucszBufSend);
    if(_SCALER_WTITE_16BITSREGISTERS_CMD != ucszBufSend[0])
    {
        return _ERROR_COMM_RW_REG_COMMAND;
    }

    if(ucszBufSend[1] == _SCALER_DEBUG_DATA_LEN_ERROR)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    else if(ucszBufSend[1] == _SCALER_DEBUG_CHECKSUM_ERROR)
    {
        return _ERROR_COMM_RW_REG_CHECKSUM;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE Read32BitRegEx(DWORD ulReg, DWORD* pulValue)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        enumError = Read32BitRegsExThrough8To32Interface(ulReg, 1, pulValue, _INCTYPE_NONE);
        break;

    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        enumError = Read32BitRegsExThroughFW(ulReg, 1, pulValue, _INCTYPE_NONE);
        break;

    default:
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE Write32BitRegEx(DWORD ulReg, DWORD ulValue)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        enumError = Write32BitRegsExThrough8To32Interface(ulReg, 1, &ulValue, _INCTYPE_NONE);
        break;

    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        enumError = Write32BitRegsExThroughFW(ulReg, 1, &ulValue, _INCTYPE_NONE);
        break;

    default:
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE Read32BitRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usIndex = 0;
    DWORD ulRegAddr = 0;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        for(usIndex = 0; usIndex < (usLength / UC_NEW_XDATA_32BIT_REG_PAGE_LEN); usIndex++)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulRegAddr = ulReg + (usIndex * 4 * UC_NEW_XDATA_32BIT_REG_PAGE_LEN);
            }
            else
            {
                ulRegAddr = ulReg;
            }
            enumError = Read32BitRegsExThrough8To32Interface(ulRegAddr, UC_NEW_XDATA_32BIT_REG_PAGE_LEN, pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulRegAddr = ulReg + (usIndex * 4 * UC_NEW_XDATA_32BIT_REG_PAGE_LEN);
            }
            else
            {
                ulRegAddr = ulReg;
            }
            enumError = Read32BitRegsExThrough8To32Interface(ulRegAddr, (usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN), pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex < (usLength / UC_NEW_XDATA_32BIT_REG_PAGE_LEN); usIndex++)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulRegAddr = ulReg + (usIndex * 4 * UC_NEW_XDATA_32BIT_REG_PAGE_LEN);
            }
            else
            {
                ulRegAddr = ulReg;
            }

            enumError = Read32BitRegsExThroughFW(ulRegAddr, UC_NEW_XDATA_32BIT_REG_PAGE_LEN, pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulRegAddr = ulReg + (usIndex * 4 * UC_NEW_XDATA_32BIT_REG_PAGE_LEN);
            }
            else
            {
                ulRegAddr = ulReg;
            }
            enumError = Read32BitRegsExThroughFW(ulRegAddr, (usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN), pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    default:
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE Write32BitRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usIndex = 0;
    DWORD ulRegAddr = 0;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        for(usIndex = 0; usIndex < (usLength / UC_NEW_XDATA_32BIT_REG_PAGE_LEN); usIndex++)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulRegAddr = ulReg + (usIndex * 4 * UC_NEW_XDATA_32BIT_REG_PAGE_LEN);
            }
            else
            {
                ulRegAddr = ulReg;
            }
            enumError = Write32BitRegsExThrough8To32Interface(ulRegAddr, UC_NEW_XDATA_32BIT_REG_PAGE_LEN, pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulRegAddr = ulReg + (usIndex * 4 * UC_NEW_XDATA_32BIT_REG_PAGE_LEN);
            }
            else
            {
                ulRegAddr = ulReg;
            }
            enumError = Write32BitRegsExThrough8To32Interface(ulRegAddr, (usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN), pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex < (usLength / UC_NEW_XDATA_32BIT_REG_PAGE_LEN); usIndex++)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulRegAddr = ulReg + (usIndex * 4 * UC_NEW_XDATA_32BIT_REG_PAGE_LEN);
            }
            else
            {
                ulRegAddr = ulReg;
            }
            enumError = Write32BitRegsExThroughFW(ulRegAddr, UC_NEW_XDATA_32BIT_REG_PAGE_LEN, pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulRegAddr = ulReg + (usIndex * 4 * UC_NEW_XDATA_32BIT_REG_PAGE_LEN);
            }
            else
            {
                ulRegAddr = ulReg;
            }
            enumError = Write32BitRegsExThroughFW(ulRegAddr, (usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN), pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    default:
        break;
    }
    return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE Write32BitRegsExThrough8To32Interface(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    if(usLength > UC_NEW_XDATA_32BIT_REG_PAGE_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }

    // 0xFDE5[6] = 1b'0, rbus_mode_sel: 0:from 8051 8to32 interface directly
    // 0xFDE5[5] = 1b'0 group_mux_sel:0: group0
    // 0xFDE5[2] = 1b'0  turn on auto increase
    if(enumInc == _INCTYPE_AUTO)
    {
        enumError = WriteRegBitEx(_REG_FDE5, (BYTE)(~(_BIT6 | _BIT5 | _BIT2)), 0);
    }
    else
    {
        // turn off auto increase
        enumError = WriteRegBitEx(_REG_FDE5, (BYTE)(~(_BIT6 | _BIT5 | _BIT2)), _BIT2);
    }

    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // Set address 
    enumError = WriteRegEx(_REG_FDD0, HIBYTE(HIWORD(ulReg)));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    enumError = WriteRegEx(_REG_FDD1, LOBYTE(HIWORD(ulReg)));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    enumError = WriteRegEx(_REG_FDD2, HIBYTE(LOWORD(ulReg)));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    enumError = WriteRegEx(_REG_FDD3, LOBYTE(LOWORD(ulReg)));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    for(WORD i = 0; i < usLength; i++)
    {
        // Set data 
        enumError = WriteRegEx(_REG_FDD4, HIBYTE(HIWORD(pulBuf[i])));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = WriteRegEx(_REG_FDD5, LOBYTE(HIWORD(pulBuf[i])));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = WriteRegEx(_REG_FDD6, HIBYTE(LOWORD(pulBuf[i])));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = WriteRegEx(_REG_FDD7, LOBYTE(LOWORD(pulBuf[i])));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // 0xFDE6[0] = 1b'1 Write Enable
        enumError = WriteRegBitEx(_REG_FDE6, (BYTE)(~(_BIT0)), _BIT0);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE Read32BitRegsExThrough8To32Interface(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucszBuf[4] ={0};

    if(usLength > UC_NEW_XDATA_32BIT_REG_PAGE_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }

    // 0xFDE5[6] = 1b'0, rbus_mode_sel: 0:from 8051 8to32 interface directly
    // 0xFDE5[5] = 1b'0 group_mux_sel:0: group0
    // 0xFDE5[2] = 1b'0  turn on auto increase
    if(enumInc == _INCTYPE_AUTO)
    {
        enumError = WriteRegBitEx(_REG_FDE5, (BYTE)(~(_BIT6 | _BIT5 | _BIT2)), 0);
    }
    else
    {
        // turn off auto increase
        enumError = WriteRegBitEx(_REG_FDE5, (BYTE)(~(_BIT6 | _BIT5 | _BIT2)), _BIT2);
    }

    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // Set address 
    enumError = WriteRegEx(_REG_FDD0, HIBYTE(HIWORD(ulReg)));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    enumError = WriteRegEx(_REG_FDD1, LOBYTE(HIWORD(ulReg)));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    enumError = WriteRegEx(_REG_FDD2, HIBYTE(LOWORD(ulReg)));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    enumError = WriteRegEx(_REG_FDD3, LOBYTE(LOWORD(ulReg)));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    for(WORD i = 0; i < usLength; i++)
    {
        // 0xFDE7[0] = 1b'1 Read Enable
        enumError = WriteRegBitEx(_REG_FDE7, (BYTE)(~(_BIT0)), _BIT0);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        // Set data 
        memset(ucszBuf, 0, sizeof(ucszBuf));
        enumError = ReadRegEx(_REG_FDD4, &ucszBuf[0]);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = ReadRegEx(_REG_FDD5, &ucszBuf[1]);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = ReadRegEx(_REG_FDD6, &ucszBuf[2]);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = ReadRegEx(_REG_FDD7, &ucszBuf[3]);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        pulBuf[i] = MAKELONG((MAKEWORD(ucszBuf[3], ucszBuf[2])), (MAKEWORD(ucszBuf[1], ucszBuf[0])));
    }
    return enumError;

}

STRUCT_ENUM_ERROR_TYPE Write32BitRegsExThroughFW(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    BYTE ucszBufSend[UC_NEW_XDATA_MAX_LEN + 10] ={0};
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucChecksum = 0;

    if(usLength > UC_NEW_XDATA_32BIT_REG_PAGE_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    if(enumInc == _INCTYPE_AUTO)
    {
        ucszBufSend[5] = TRUE;
    }
    else
    {
        ucszBufSend[5] = FALSE;
    }
    ucszBufSend[0] = HIBYTE(HIWORD(ulReg));
    ucszBufSend[1] = LOBYTE(HIWORD(ulReg));
    ucszBufSend[2] = HIBYTE(LOWORD(ulReg));
    ucszBufSend[3] = LOBYTE(LOWORD(ulReg));
    ucszBufSend[4] = (BYTE)usLength;
    for(WORD i = 0; i < usLength; i++)
    {
        ucszBufSend[6 + i * 4] = HIBYTE(HIWORD(pulBuf[i]));
        ucszBufSend[7 + i * 4] = LOBYTE(HIWORD(pulBuf[i]));
        ucszBufSend[8 + i * 4] = HIBYTE(LOWORD(pulBuf[i]));
        ucszBufSend[9 + i * 4] = LOBYTE(LOWORD(pulBuf[i]));
    }
    ucChecksum = 0;
    for(WORD i = 0; i < (usLength * 4 + 6); i++)
    {
        ucChecksum += ucszBufSend[i];
    }
    ucszBufSend[6 + usLength * 4] = ucChecksum;

    enumError = I2CWrite(g_ucDebugSlave, _SCALER_WTITE_32BITSREGISTERS_CMD, usLength * 4 + 7, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    memset(ucszBufSend, 0, sizeof(ucszBufSend));
    enumError = I2CRead(g_ucDebugSlave, _SCALER_USELESS_READ_CMD, 2, ucszBufSend);
    if(_SCALER_WTITE_32BITSREGISTERS_CMD != ucszBufSend[0])
    {
        return _ERROR_COMM_RW_REG_COMMAND;
    }

    if(ucszBufSend[1] == _SCALER_DEBUG_DATA_LEN_ERROR)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    else if(ucszBufSend[1] == _SCALER_DEBUG_CHECKSUM_ERROR)
    {
        return _ERROR_COMM_RW_REG_CHECKSUM;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE Read32BitRegsExThroughFW(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    BYTE ucszBufSend[UC_NEW_XDATA_MAX_LEN + 10] ={0};
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucChecksum = 0;

    if(usLength > UC_NEW_XDATA_32BIT_REG_PAGE_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    if(enumInc == _INCTYPE_AUTO)
    {
        ucszBufSend[5] = TRUE;
    }
    else
    {
        ucszBufSend[5] = FALSE;
    }
    ucszBufSend[0] = HIBYTE(HIWORD(ulReg));
    ucszBufSend[1] = LOBYTE(HIWORD(ulReg));
    ucszBufSend[2] = HIBYTE(LOWORD(ulReg));
    ucszBufSend[3] = LOBYTE(LOWORD(ulReg));
    ucszBufSend[4] = (BYTE)usLength;
    ucChecksum = 0;
    for(int i = 0; i < 6; i++)
    {
        ucChecksum += ucszBufSend[i];
    }
    ucszBufSend[6] = ucChecksum;
    enumError = I2CWrite(g_ucDebugSlave, _SCALER_READ_32BITSREGISTERS_CMD, 7, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    memset(ucszBufSend, 0, sizeof(ucszBufSend));
    enumError = I2CRead(g_ucDebugSlave, _SCALER_USELESS_READ_CMD, (usLength * sizeof(DWORD)) + 3, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    if(usLength != ucszBufSend[1])
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    ucChecksum = 0;
    for(int i = 0; i < usLength * 4; i++)
    {
        ucChecksum += ucszBufSend[i + 2];
    }
    if(ucChecksum != ucszBufSend[2 + 4 * usLength])
    {
        return _ERROR_COMM_RW_REG_CHECKSUM;
    }

    for(int i = 0; i < usLength; i++)
    {
        pulBuf[i] = MAKELONG((MAKEWORD(ucszBufSend[5 + i * 4], ucszBufSend[4 + i * 4])), (MAKEWORD(ucszBufSend[3 + i * 4], ucszBufSend[2 + i * 4])));
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadDDRRegEx(DWORD ulReg, DWORD* pulValue)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        enumError = ReadDDRRegsExThroughMCMMode(ulReg, 1, pulValue, _INCTYPE_NONE);
        break;

    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        enumError = ReadDDRRegsExThroughFW(ulReg, 1, pulValue, _INCTYPE_NONE);
        break;

    default:
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteDDRRegEx(DWORD ulReg, DWORD ulValue)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        enumError = WriteDDRRegsExThroughMCMMode(ulReg, 1, &ulValue, _INCTYPE_NONE);
        break;

    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        enumError = WriteDDRRegsExThroughFW(ulReg, 1, &ulValue, _INCTYPE_NONE);
        break;

    default:
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadDDRRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usIndex = 0;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        for(usIndex = 0; usIndex / UC_NEW_XDATA_32BIT_REG_PAGE_LEN; usIndex++)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulReg = ulReg + usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN;
            }

            enumError = ReadDDRRegsExThroughMCMMode(ulReg, UC_NEW_XDATA_32BIT_REG_PAGE_LEN, pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulReg = ulReg + usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN;
            }

            enumError = ReadDDRRegsExThroughMCMMode(ulReg, (usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN), pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex / UC_NEW_XDATA_32BIT_REG_PAGE_LEN; usIndex++)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulReg = ulReg + usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN;
            }

            enumError = ReadDDRRegsExThroughFW(ulReg, UC_NEW_XDATA_32BIT_REG_PAGE_LEN, pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulReg = ulReg + usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN;
            }
  
            enumError = ReadDDRRegsExThroughFW(ulReg, (usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN), pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    default:
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteDDRRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usIndex = 0;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        for(usIndex = 0; usIndex / UC_NEW_XDATA_32BIT_REG_PAGE_LEN; usIndex++)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulReg = ulReg + usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN;
            }

            enumError = WriteDDRRegsExThroughMCMMode(ulReg, UC_NEW_XDATA_32BIT_REG_PAGE_LEN, pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulReg = ulReg + usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN;
            }

            enumError = WriteDDRRegsExThroughMCMMode(ulReg, (usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN), pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex / UC_NEW_XDATA_32BIT_REG_PAGE_LEN; usIndex++)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulReg = ulReg + usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN;
            }

            enumError = WriteDDRRegsExThroughFW(ulReg, UC_NEW_XDATA_32BIT_REG_PAGE_LEN, pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN) != 0)
        {
            if(enumInc == _INCTYPE_AUTO)
            {
                ulReg = ulReg + usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN;
            }

            enumError = WriteDDRRegsExThroughFW(ulReg, (usLength % UC_NEW_XDATA_32BIT_REG_PAGE_LEN), pulBuf + (usIndex * UC_NEW_XDATA_32BIT_REG_PAGE_LEN), enumInc);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    default:
        break;
    }
    return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE WriteDDRRegsExThroughMCMMode(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucszBuf[16] ={0};
    INT nTryCount = N_TRY_COUNT;

    // Set DDR config (DDR Num & burst Len)
    enumError = WriteRegEx(_REG_3701, 0x82);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // Set target memory address
    for(int i = 0; i < usLength; i++)
    {
        enumError = WriteRegEx(_REG_3704, HIBYTE(HIWORD(ulReg)));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = WriteRegEx(_REG_3705, LOBYTE(HIWORD(ulReg)));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = WriteRegEx(_REG_3706, HIBYTE(LOWORD(ulReg)));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = WriteRegEx(_REG_3707, LOBYTE(LOWORD(ulReg)));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }

        // Set DDR Write Cmd
        enumError = WriteRegBitEx(_REG_3700, (BYTE)(~(_BIT7 | _BIT6 | _BIT5)), (4 << 5));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        memset(ucszBuf, 0, sizeof(ucszBuf));
        ucszBuf[0] = HIBYTE(HIWORD(pulBuf[i]));
        ucszBuf[1] = LOBYTE(HIWORD(pulBuf[i]));
        ucszBuf[2] = HIBYTE(LOWORD(pulBuf[i]));
        ucszBuf[3] = LOBYTE(LOWORD(pulBuf[i]));
        for(int j = 0; j < 16; j++)
        {
            enumError = WriteRegEx((WORD)(_REG_3710 + i), ucszBuf[i]);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        // Wait for Polling Write finish
        while(nTryCount > 0)
        {
            ucszBuf[0] = 0;
            enumError = ReadRegEx(_REG_3700, &ucszBuf[0]);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }

            if((ucszBuf[0] & 0xE0) == 0x00)
            {
                return _ERROR_SUCCESS;
            }
            Sleep(2);

            --nTryCount;
        }
        if(enumInc == _INCTYPE_AUTO)
        {
            ulReg += 4;
        }

    }
    return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE ReadDDRRegsExThroughMCMMode(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucszBuf[16] ={0};
    INT nTryCount = N_TRY_COUNT;

    // Set DDR config (DDR Num & burst Len)
    enumError = WriteRegEx(_REG_3701, 0x82);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    // Set target memory address
    for(int i = 0; i < usLength; i++)
    {
        enumError = WriteRegEx(_REG_3704, HIBYTE(HIWORD(ulReg)));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = WriteRegEx(_REG_3705, LOBYTE(HIWORD(ulReg)));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = WriteRegEx(_REG_3706, HIBYTE(LOWORD(ulReg)));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = WriteRegEx(_REG_3707, LOBYTE(LOWORD(ulReg)));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        // Read data buffer to clear uncleared ready-to-read flag (if it exists).
        for(int j = 0; j < 16; j++)
        {
            enumError = ReadRegEx((WORD)(_REG_3710 + j), &ucszBuf[j]);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }

        // Set DDR Read Cmd
        enumError = WriteRegBitEx(_REG_3700, (BYTE)(~(_BIT7 | _BIT6 | _BIT5)), (5 << 5));
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        // Wait for Pollig Read finish
        while(nTryCount > 0)
        {
            ucszBuf[0] = 0;
            enumError = ReadRegEx(_REG_3754, &ucszBuf[0]);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }

            if((ucszBuf[0] & 0xFE) == 0x01)
            {
                return _ERROR_SUCCESS;
            }
            Sleep(2);

            --nTryCount;
        }

        memset(ucszBuf, 0, sizeof(ucszBuf));
        for(int j = 0; j < 16; j++)
        {
            enumError = ReadRegEx((WORD)(_REG_3710 + j), &ucszBuf[j]);
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        pulBuf[i] = MAKELONG((MAKEWORD(ucszBuf[0], ucszBuf[1])), (MAKEWORD(ucszBuf[2], ucszBuf[3])));
        if(enumInc == _INCTYPE_AUTO)
        {
            ulReg += 4;
        }
    }
    return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE WriteDDRRegsExThroughFW(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    BYTE ucszBufSend[UC_NEW_XDATA_MAX_LEN + 10] ={0};
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucChecksum = 0;

    if(usLength > UC_NEW_XDATA_32BIT_REG_PAGE_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    if(enumInc == _INCTYPE_AUTO)
    {
        ucszBufSend[5] = TRUE;
    }
    else
    {
        ucszBufSend[5] = FALSE;
    }
    ucszBufSend[0] = HIBYTE(HIWORD(ulReg));
    ucszBufSend[1] = LOBYTE(HIWORD(ulReg));
    ucszBufSend[2] = HIBYTE(LOWORD(ulReg));
    ucszBufSend[3] = LOBYTE(LOWORD(ulReg));
    ucszBufSend[4] = (BYTE)usLength;
    for(WORD i = 0; i < usLength; i++)
    {
        ucszBufSend[6 + i * 4] = HIBYTE(HIWORD(pulBuf[i]));
        ucszBufSend[7 + i * 4] = LOBYTE(HIWORD(pulBuf[i]));
        ucszBufSend[8 + i * 4] = HIBYTE(LOWORD(pulBuf[i]));
        ucszBufSend[9 + i * 4] = LOBYTE(LOWORD(pulBuf[i]));
    }

    ucChecksum = 0;
    for(WORD i = 0; i < (usLength * 4 + 6); i++)
    {
        ucChecksum += ucszBufSend[i];
    }
    ucszBufSend[6 + usLength * 4] = ucChecksum;

    enumError = I2CWrite(g_ucDebugSlave, _SCALER_WTITE_DDRREGISTERS_CMD, usLength * 4 + 7, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    memset(ucszBufSend, 0, sizeof(ucszBufSend));
    enumError = I2CRead(g_ucDebugSlave, _SCALER_USELESS_READ_CMD, 2, ucszBufSend);
    if(_SCALER_WTITE_DDRREGISTERS_CMD != ucszBufSend[0])
    {
        return _ERROR_COMM_RW_REG_COMMAND;
    }

    if(ucszBufSend[1] == _SCALER_DEBUG_DATA_LEN_ERROR)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    else if(ucszBufSend[1] == _SCALER_DEBUG_CHECKSUM_ERROR)
    {
        return _ERROR_COMM_RW_REG_CHECKSUM;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadDDRRegsExThroughFW(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc)
{
    BYTE ucszBufSend[UC_NEW_XDATA_MAX_LEN + 10] ={0};
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucChecksum = 0;

    if(usLength > UC_NEW_XDATA_32BIT_REG_PAGE_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    if(enumInc == _INCTYPE_AUTO)
    {
        ucszBufSend[5] = TRUE;
    }
    else
    {
        ucszBufSend[5] = FALSE;
    }
    ucszBufSend[0] = HIBYTE(HIWORD(ulReg));
    ucszBufSend[1] = LOBYTE(HIWORD(ulReg));
    ucszBufSend[2] = HIBYTE(LOWORD(ulReg));
    ucszBufSend[3] = LOBYTE(LOWORD(ulReg));
    ucszBufSend[4] = (BYTE)usLength;
    ucChecksum = 0;
    for(int i = 0; i < 6; i++)
    {
        ucChecksum += ucszBufSend[i];
    }
    ucszBufSend[6] = ucChecksum;
    enumError = I2CWrite(g_ucDebugSlave, _SCALER_READ_DDRREGISTERS_CMD, 7, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    memset(ucszBufSend, 0, sizeof(ucszBufSend));
    enumError = I2CRead(g_ucDebugSlave, _SCALER_USELESS_READ_CMD, (usLength * sizeof(DWORD)) + 3, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    if(usLength != ucszBufSend[1])
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    ucChecksum = 0;
    for(int i = 0; i < usLength * 4; i++)
    {
        ucChecksum += ucszBufSend[i + 2];
    }
    if(ucChecksum != ucszBufSend[2 + 4 * usLength])
    {
        return _ERROR_COMM_RW_REG_CHECKSUM;
    }

    for(int i = 0; i < usLength; i++)
    {
        pulBuf[i] = MAKELONG((MAKEWORD(ucszBufSend[5 + i * 4], ucszBufSend[4 + i * 4])), (MAKEWORD(ucszBufSend[3 + i * 4], ucszBufSend[2 + i * 4])));
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadPWM2SPIDev(BYTE ucDevIndex, BYTE ucPwmStartIndex, BYTE ucPwmNum, WORD *pusBuf)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usIndex = 0;
    WORD usStartAddr = 0;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        enumError = _ERROR_COMM_UNSUPPORT_MCUREGACCESSMODE;
        break;
    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex < (ucPwmNum / UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN); usIndex++)
        {
            usStartAddr = ucPwmStartIndex + (usIndex * UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN);
            enumError = ReadPWM2SPIDevThroughFW(ucDevIndex, (BYTE)usStartAddr, UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN, pusBuf + (usIndex * UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN));
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((ucPwmNum % UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN) != 0)
        {
            usStartAddr = ucPwmStartIndex + (usIndex * UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN);
            enumError = ReadPWM2SPIDevThroughFW(ucDevIndex, (BYTE)usStartAddr, (ucPwmNum % UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN), pusBuf + (usIndex * UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN));
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    default:
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WritePWM2SPIDev(BYTE ucDevIndex, BYTE ucPwmStartIndex, BYTE ucPwmNum, WORD *pusBuf)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usIndex = 0;
    WORD usStartAddr = 0;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        enumError = _ERROR_COMM_UNSUPPORT_MCUREGACCESSMODE;
        break;
    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex < (ucPwmNum / UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN); usIndex++)
        {
            usStartAddr = ucPwmStartIndex + (usIndex * UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN);
            enumError = WritePWM2SPIDevThroughFW(ucDevIndex, (BYTE)usStartAddr, UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN, pusBuf + (usIndex * UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN));
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((ucPwmNum % UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN) != 0)
        {
            usStartAddr = ucPwmStartIndex + (usIndex * UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN);
            enumError = WritePWM2SPIDevThroughFW(ucDevIndex, (BYTE)usStartAddr, (ucPwmNum % UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN), pusBuf + (usIndex * UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN));
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    default:
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadPWM2SPIDevThroughFW(BYTE ucDevIndex, BYTE ucPwmStartIndex, BYTE ucPwmNum, WORD *pusBuf)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucChecksum = 0;
    BYTE ucszBufSend[UC_NEW_XDATA_MAX_LEN + 10] ={0};

    if(ucPwmNum > UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }

    ucszBufSend[0] = ucDevIndex;
    ucszBufSend[1] = ucPwmStartIndex;
    ucszBufSend[2] = ucPwmNum;
    ucChecksum = 0;
    for(WORD i = 0; i < 3; i++)
    {
        ucChecksum += ucszBufSend[i];
    }
    ucszBufSend[3] = ucChecksum;


    enumError = I2CWrite(g_ucDebugSlave, _SCALER_READ_PWM2SPI_DEV_CMD, 4, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    memset(ucszBufSend, 0, sizeof(ucszBufSend));
    enumError = I2CRead(g_ucDebugSlave, _SCALER_USELESS_READ_CMD, ucPwmNum * 2 + 3, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    if(_SCALER_READ_PWM2SPI_DEV_CMD != ucszBufSend[0])
    {
        return _ERROR_COMM_RW_REG_COMMAND;
    }

    if(ucPwmNum != ucszBufSend[1])
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    ucChecksum = 0;
    for(int i = 0; i < ucPwmNum * 2; i++)
    {
        ucChecksum += ucszBufSend[i + 2];
    }
    if(ucChecksum != ucszBufSend[2 + 2 * ucPwmNum])
    {
        return _ERROR_COMM_RW_REG_CHECKSUM;
    }

    for(int i = 0; i < ucPwmNum; i++)
    {
        pusBuf[i] = MAKEWORD(ucszBufSend[2 + i * 2], ucszBufSend[3 + i * 2]);
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WritePWM2SPIDevThroughFW(BYTE ucDevIndex, BYTE ucPwmStartIndex, BYTE ucPwmNum, WORD *pusBuf)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucChecksum = 0;
    BYTE ucszBufSend[UC_NEW_XDATA_MAX_LEN + 10] ={0};

    if(ucPwmNum > UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }

    ucszBufSend[0] = ucDevIndex;
    ucszBufSend[1] = ucPwmStartIndex;
    ucszBufSend[2] = ucPwmNum;
    for(WORD i = 0; i < ucPwmNum; i++)
    {
        ucszBufSend[3 + i * 2] = LOBYTE(pusBuf[i]);
        ucszBufSend[4 + i * 2] = HIBYTE(pusBuf[i]);
    }

    ucChecksum = 0;
    for(WORD i = 0; i < (ucPwmNum * 2 + 3); i++)
    {
        ucChecksum += ucszBufSend[i];
    }
    ucszBufSend[3 + ucPwmNum * 2] = ucChecksum;

    enumError = I2CWrite(g_ucDebugSlave, _SCALER_WTITE_PWM2SPI_DEV_CMD, ucPwmNum * 2 + 4, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    memset(ucszBufSend, 0, sizeof(ucszBufSend));
    enumError = I2CRead(g_ucDebugSlave, _SCALER_USELESS_READ_CMD, 2, ucszBufSend);
    if(_SCALER_WTITE_PWM2SPI_DEV_CMD != ucszBufSend[0])
    {
        return _ERROR_COMM_RW_REG_COMMAND;
    }

    if(ucszBufSend[1] == _SCALER_DEBUG_DATA_LEN_ERROR)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    else if(ucszBufSend[1] == _SCALER_DEBUG_CHECKSUM_ERROR)
    {
        return _ERROR_COMM_RW_REG_CHECKSUM;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadPWM2SPIReg(BYTE ucDevIndex, BYTE ucRegStartAddr, BYTE ucLength, BYTE *pucBuf)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usIndex = 0;
    WORD usStartAddr = 0;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        enumError = _ERROR_COMM_UNSUPPORT_MCUREGACCESSMODE;
        break;
    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex < (ucLength / UC_NEW_XDATA_MAX_LEN); usIndex++)
        {
            usStartAddr = ucRegStartAddr + (usIndex * UC_NEW_XDATA_MAX_LEN);
            enumError = ReadPWM2SPIRegThroughFW(ucDevIndex, (BYTE)usStartAddr, UC_NEW_XDATA_MAX_LEN, pucBuf + (usIndex * UC_NEW_XDATA_MAX_LEN));
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((ucLength % UC_NEW_XDATA_MAX_LEN) != 0)
        {
            usStartAddr = ucRegStartAddr + (usIndex * UC_NEW_XDATA_MAX_LEN);
            enumError = ReadPWM2SPIRegThroughFW(ucDevIndex, (BYTE)usStartAddr, (ucLength % UC_NEW_XDATA_MAX_LEN), pucBuf + (usIndex * UC_NEW_XDATA_MAX_LEN));
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    default:
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WritePWM2SPIReg(BYTE ucDevIndex, BYTE ucRegStartAddr, BYTE ucLength, BYTE *pucBuf)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usIndex = 0;
    WORD usStartAddr = 0;

    switch(g_enumDebugMode)
    {
    case _DEBUG_DEBUG:
    case _DEBUG_ISP:
    case _DEBUG_STEPTRACE:
        enumError = _ERROR_COMM_UNSUPPORT_MCUREGACCESSMODE;
        break;
    case _DEBUG_XDATA:
    case _DEBUG_NEW_XDATA:
        for(usIndex = 0; usIndex < (ucLength / UC_NEW_XDATA_MAX_LEN); usIndex++)
        {
            usStartAddr = ucRegStartAddr + (usIndex * UC_NEW_XDATA_MAX_LEN);
            enumError = WritePWM2SPIRegThroughFW(ucDevIndex, (BYTE)usStartAddr, UC_NEW_XDATA_MAX_LEN, pucBuf + (usIndex * UC_NEW_XDATA_MAX_LEN));
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        if((ucLength % UC_NEW_XDATA_MAX_LEN) != 0)
        {
            usStartAddr = ucRegStartAddr + (usIndex * UC_NEW_XDATA_MAX_LEN);
            enumError = WritePWM2SPIRegThroughFW(ucDevIndex, (BYTE)usStartAddr, (ucLength % UC_NEW_XDATA_MAX_LEN), pucBuf + (usIndex * UC_NEW_XDATA_MAX_LEN));
            if(enumError != _ERROR_SUCCESS)
            {
                return enumError;
            }
        }
        break;
    default:
        break;
    }
    return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadPWM2SPIRegThroughFW(BYTE ucDevIndex, BYTE ucRegStartAddr, BYTE ucLength, BYTE *pucBuf)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucChecksum = 0;
    BYTE ucszBufSend[UC_NEW_XDATA_MAX_LEN] ={0};

    if(ucLength > UC_NEW_XDATA_MAX_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }

    ucszBufSend[0] = ucDevIndex;
    ucszBufSend[1] = ucRegStartAddr;
    ucszBufSend[2] = ucLength;
    ucChecksum = 0;
    for(WORD i = 0; i < 3; i++)
    {
        ucChecksum += ucszBufSend[i];
    }
    ucszBufSend[3] = ucChecksum;

    enumError = I2CWrite(g_ucDebugSlave, _SCALER_READ_PWM2SPI_CMD, 4, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    memset(ucszBufSend, 0, sizeof(ucszBufSend));
    enumError = I2CRead(g_ucDebugSlave, _SCALER_USELESS_READ_CMD, ucLength + 3, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    if(_SCALER_READ_PWM2SPI_CMD != ucszBufSend[0])
    {
        return _ERROR_COMM_RW_REG_COMMAND;
    }

    if(ucLength != ucszBufSend[1])
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    ucChecksum = 0;
    for(int i = 0; i < ucLength; i++)
    {
        ucChecksum += ucszBufSend[i + 2];
    }
    if(ucChecksum != ucszBufSend[2 + ucLength])
    {
        return _ERROR_COMM_RW_REG_CHECKSUM;
    }

    memcpy(pucBuf, ucszBufSend + 2, ucLength * sizeof(BYTE));

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE WritePWM2SPIRegThroughFW(BYTE ucDevIndex, BYTE ucRegStartAddr, BYTE ucLength, BYTE *pucBuf)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucChecksum = 0;
    BYTE ucszBufSend[UC_NEW_XDATA_MAX_LEN + 10] ={0};

    if(ucLength > UC_NEW_XDATA_PWM_SPI_REG_PAGE_LEN)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }

    ucszBufSend[0] = ucDevIndex;
    ucszBufSend[1] = ucRegStartAddr;
    ucszBufSend[2] = ucLength;
    for(WORD i = 0; i < ucLength; i++)
    {
        ucszBufSend[3 + i] = pucBuf[i];
    }

    ucChecksum = 0;
    for(WORD i = 0; i < (ucLength + 3); i++)
    {
        ucChecksum += ucszBufSend[i];
    }
    ucszBufSend[3 + ucLength] = ucChecksum;

    enumError = I2CWrite(g_ucDebugSlave, _SCALER_WTITE_PWM2SPI_CMD, ucLength + 4, ucszBufSend);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    memset(ucszBufSend, 0, sizeof(ucszBufSend));
    enumError = I2CRead(g_ucDebugSlave, _SCALER_USELESS_READ_CMD, 2, ucszBufSend);
    if(_SCALER_WTITE_PWM2SPI_CMD != ucszBufSend[0])
    {
        return _ERROR_COMM_RW_REG_COMMAND;
    }

    if(ucszBufSend[1] == _SCALER_DEBUG_DATA_LEN_ERROR)
    {
        return _ERROR_COMM_RW_REG_PAGE_LEN;
    }
    else if(ucszBufSend[1] == _SCALER_DEBUG_CHECKSUM_ERROR)
    {
        return _ERROR_COMM_RW_REG_CHECKSUM;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE EnterStepTraceDebugMode()
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucszBuf[2] ={0x5A, 0x81};

    enumError = I2CWrite(g_ucIspSlave, 0x6F, 2, ucszBuf);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE StepTraceRead(WORD usXdataAddr, BYTE* pucBuf)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucValue = 0;

    if(pucBuf == NULL)
    {
        return _ERROR_COMM_PARAMETER;
    }

    //This is work acround, before and ICD confirmed that there are HW bug.
    //But through this process can correctly read the value.
    if(((usXdataAddr & 0xFF00) == 0xFD00) || ((usXdataAddr & 0xFF00) == 0xFE00))
    {
        StepTraceRead(0x0006, pucBuf);
    }
    enumError = EnterStepTraceDebugMode();
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    //////////////////////////////////////////////////////////////////////////
    // XDATA Address Auto Increase; 
    // Force to read/write scalar registers using xdata remapping method. 
    // and access scalar registers through XDATA address/data port.
    ucValue = 0x00;
    enumError = I2CRead(g_ucIspSlave, 0xD0, 1, &ucValue);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    ucValue = (ucValue & 0xE3) | 0x18;
    enumError = I2CWriteByte(g_ucIspSlave, 0xD0, ucValue);

    // XDATA Address MSB
    enumError = I2CWriteByte(g_ucIspSlave, 0xD5, ((usXdataAddr & 0xFF00) >> 8));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // XDATA Address LSB
    enumError = I2CWriteByte(g_ucIspSlave, 0xD6, (usXdataAddr & 0x00FF));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // XDATA Address LSB
    enumError = I2CRead(g_ucIspSlave, 0xD7, 1, pucBuf);

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE StepTraceWrite(WORD usXdataAddr, BYTE ucValue)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucTmp = 0;
    enumError = EnterStepTraceDebugMode();
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }

    //////////////////////////////////////////////////////////////////////////
    // XDATA Address Auto Increase; 
    // Force to read/write scalar registers using xdata remapping method. 
    // and access scalar registers through XDATA address/data port.
    // Eable Write to XDATA address space
    ucTmp = 0x00;
    enumError = I2CRead(g_ucIspSlave, 0xD0, 1, &ucTmp);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    ucTmp = (ucTmp & 0xE3) | 0x1C;
    enumError = I2CWriteByte(g_ucIspSlave, 0xD0, ucTmp);

    // XDATA Address MSB
    enumError = I2CWriteByte(g_ucIspSlave, 0xD5, ((usXdataAddr & 0xFF00) >> 8));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // XDATA Address LSB
    enumError = I2CWriteByte(g_ucIspSlave, 0xD6, (usXdataAddr & 0x00FF));
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    // XDATA Address LSB
    enumError = I2CWriteByte(g_ucIspSlave, 0xD7, ucValue);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    //////////////////////////////////////////////////////////////////////////
    // XDATA Address Auto Increase; 
    // Force to read/write scalar registers using xdata remapping method. 
    // and access scalar registers through XDATA address/data port.
    // Disable Write to XDATA address space
    ucTmp = 0x00;
    enumError = I2CRead(g_ucIspSlave, 0xD0, 1, &ucTmp);
    if(enumError != _ERROR_SUCCESS)
    {
        return enumError;
    }
    ucTmp = (ucTmp & 0xFB);
    enumError = I2CWriteByte(g_ucIspSlave, 0xD0, ucTmp);

    return enumError;
}

STRUCT_ENUM_ERROR_TYPE AutoEnterIspMode(WORD usRetryTimes)
{
    BYTE ucValue = 0;
    WORD usIndex = 0;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    WORD usCount = 0;

    if(GetCommID() == _ENUM_COMM_TYPECUSB)
    {
        return SendUsbPacket(_USB_VENDOR_ISP_ENABLE, 1, 0, 0, &ucValue);
    }

    if((rsdI2CWrite == NULL) || (rsdI2CRead == NULL))
    {
        return _ERROR_COMM_NO_INITIAL;
    }
    while(usCount < usRetryTimes)
    {
        for(usIndex = 0; usIndex < US_SCALER_SLAVE_ADDR_GROUP_COUNT; usIndex++)
        {
            BYTE ucValue = 0x80;
            if(I2CWrite(ST_SCALER_SLAVE_ADRR[usIndex].ucIspSlave, 0x6F, 1, &ucValue) == _ERROR_SUCCESS)
            {
                ucValue = 0;
                enumError = I2CRead(ST_SCALER_SLAVE_ADRR[usIndex].ucIspSlave, 0x6F, 1, &ucValue);
                if((enumError == _ERROR_SUCCESS) && ((ucValue & _BIT7) == _BIT7))
                {
                    g_ucDebugSlave = ST_SCALER_SLAVE_ADRR[usIndex].ucDebugSlave;
                    g_ucIspSlave = ST_SCALER_SLAVE_ADRR[usIndex].ucIspSlave;
                    g_ucIspContinuousSlave = ST_SCALER_SLAVE_ADRR[usIndex].ucIspContinuousSlave;
                    return _ERROR_SUCCESS;
                }
            }
        }
        usCount++;
    }

    return _ERROR_COMM_ENTER_ISP_MODE;
}

STRUCT_ENUM_ERROR_TYPE SetSpecialCommType(STRUCT_ENUM_SPECIAL_COMM_TYPE enumSpecialCommType)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    switch(enumSpecialCommType)
    {
    case _ENUM_SPECIAL_COMM_IICMASTER:
        enumError = ScalerStop();
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        enumError = I2CMasterInitial(_ENUM_IIC_MASTER_SPEED_100K);
        if(enumError != _ERROR_SUCCESS)
        {
            return enumError;
        }
        break;
    default:
        break;

    }
    g_enumSpecialCommType = enumSpecialCommType;
    g_ucCurPage = 0x00;
    g_bPageMark = FALSE;

    return _ERROR_SUCCESS;
}

STRUCT_ENUM_SPECIAL_COMM_TYPE GetSpecialCommType()
{
    return g_enumSpecialCommType;
}




