#include "stdafx.h"
#include "CpRsFuncBase.h"

#define MAX_ABSOLUTE_PATH_LENGTH 40960


CCpRsString GetCurrentProcessDir(VOID* hModule)
{
    CHAR cBuf[_MAX_PATH];  
    int i;  
    CHAR *pcDest;

    // get exe 
    if(hModule == NULL)
    {
        int len = readlink("/proc/self/exe", cBuf, _MAX_PATH);  
        if (len < 0 || len >= _MAX_PATH)  
        {  
            return NULL;  
        }  
          
        cBuf[len] = '\0';  
        for(i = len; i >= 0; i--)  
        {  
            if(cBuf[i] == '/')  
            {  
                cBuf[i + 1] = '\0';  
                break;  
            }  
        }  
    }
    else // .so path
    {
        Dl_info dlinfo;
        int ret=0;
        ret = dladdr(hModule,&dlinfo);
        if(!ret)
        {
            cBuf[0]='\0' ;
        }
        else
        {
            strncpy(cBuf, dlinfo.dli_fname, _MAX_PATH);
            pcDest = strrchr(cBuf, '/');
            if(pcDest != NULL)
            {
                pcDest[1] = '\0';
            }
            else
            {
                pcDest = strrchr(cBuf, '\\');
                if(pcDest != NULL)
                {
                    pcDest[1] = '\0';
                }
                else
                {
                    memcpy(cBuf,"./",sizeof("./"));
                }
            }
        }
        
    }
    return cBuf;  
}

string GetAbsolutePath(string path)
{
    char resolved_path[MAX_ABSOLUTE_PATH_LENGTH] = {0};

    realpath(path.c_str(), resolved_path);

    return string(resolved_path);
}
